/* bxbasm : AFunct.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012      */


/* ----- function prototypes ----- */
#include "prototyp.h"


void Do_functions()
{
    if(stringcopy == 1)
    {
        copystrng_bffr();
    }

    if(asnchrstr == 1)
    {
        func_chrstr();
    }

    if(asnleftstr == 1)
    {
        func_leftstr();
    }

    if(asnrightstr == 1)
    {
        func_rightstr();
    }

    if(asnmidstr == 1)
    {
        func_midstr();
    }

    if(asnspacestr == 1)
    {
        func_spacestr();
    }

    if(asnstrsIval == 1)
    {
        func_strsIval();
    }

    if(asnstrsFval == 1)
    {
        func_strsFval();
    }

    if(asnstringstr == 1)
    {
        func_stringstr();
    }

    if(asninkeystr == 1)
    {
        func_inkeystr();
    }

    if(asninputstr == 1)
    {
        func_inputstr();
    }

    if(asnmkdstr == 1)
    {
        func_mkdstr();
    }

    if(asnmkistr == 1)
    {
        func_mkistr();
    }

    if(resetcursor == 1)
    {
        func_resetcursor();
        func_wherexy();
    }

    if(getsysdate == 1)
    {
        func_getsysdate();
    }

    if(getsystime == 1)
    {
        func_getsystime();
    }

    if(asndatestr == 1)
    {
        func_datestr();
    }

    if(asntimestr == 1)
    {
        func_timestr();
    }

    if(filecloseall == 1)
    {
        func_closeallfiles();
    }

    if(closeafile == 1)
    {
        func_closeafile();
    }

    if(getfilehandle == 1)
    {
        func_getfilehandle();
    }

    if(clearstrngbffr == 1)
    {
        func_clearstrng_bffr();
    }

    if(setupiobuffer == 1)
    {
        func_setupiobuffer();
    }

    if(asnlsetstr == 1)
    {
        func_lsetstr();
    }

    if(asnrsetstr == 1)
    {
        func_rsetstr();
    }

    if(clearallvars == 1)
    {
        func_clear_allvars();
    }

    if(clearstrvar == 1)
    {
        func_clearstrvar();
    }

    if(clearintvar == 1)
    {
        func_clearintvar();
    }

    if(clearfltvar == 1)
    {
        func_clearfltvar();
    }

    if(clearLngstrngbffr == 1)
    {
        func_clearLngstrng_bffr();
    }

    if(movstrngbffr == 1)
    {
        func_movstrng_bffr();
    }

    if(readintstr == 1)
    {
        func_readintstr();
    }

    if(readfltstr == 1)
    {
        func_readfltstr();
    }

    if(getfilelength == 1)
    {
        func_getfilelength();
    }

    if(setcolortext == 1)
    {
        func_setcolortext();
    }

    if(readQintstr == 1)
    {
        func_readQintstr();
    }

    if(asnmkqstr == 1)
    {
        func_mkqstr();
    }

    if(dimstrarray == 1)
    {
        func_dimstrarray();
    }

    if(getArryOffst == 1)
    {
        func_getArryOffst();
    }

    if(dblArryElement == 1)
    {
        func_dblArryElement();
    }

    if(quadArryElement == 1)
    {
        func_quadArryElement();
    }

    if(freeArray == 1)
    {
        func_freeArray();
    }

    if(redimarray == 1)
    {
        func_redimarray();
    }

    if(hrtimer == 1)
    {
        func_hrtimer();
    }


    Do_WinFunctions();    /* Windows GUI functions */

    Do_initialize();
}
/*---------- end Do_functions ----------*/




void func_hrtimer()
{
    writeln("; --------------------------------------------------");
    writeln("get_HiRez_Timer proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  qwTemp:QWORD");
    writeln("  LOCAL  qwFreq:QWORD");
    writeln("  LOCAL  qwCount:QWORD");
    writeln("; --------------------------------------------------");
    writeln("  FINIT");
    writeln("  invoke  QueryPerformanceFrequency, addr qwTemp");
    writeln("  FILD    qwTemp");
    writeln("  FSTP    qwFreq");
    writeln("  invoke  QueryPerformanceCounter, addr qwTemp");
    writeln("  FILD    qwTemp");
    writeln("  FSTP    qwCount");
    writeln("  FLD     qwCount");
    writeln("  FDIV    qwFreq");
    writeln("  FSTP    qRVAR");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("get_HiRez_Timer endp");
    writeln("; =========================================================================");
}
/*---------- end func_hrtimer ----------*/



void func_redimarray()
{                            /* enters: ESI = pointer address */
    writeln("; --------------------------------------------------");
    writeln("redimarray proc");
    writeln("; --------------------------------------------------");
    writeln("  push esi");
    writeln("  mov  edi, esi");
    writeln("  add  edi, 4");
    writeln("  mov  cx, word ptr [edi]");
    writeln("  dec  cx");
    writeln("  mov  ch, 0");
    writeln("  add  edi, 2");
    writeln("  mov  ax, word ptr [edi]");
    writeln("@@:");
    writeln("  .if ch < cl");
    writeln("    add  edi, 2");
    writeln("    mov  bx, word ptr [edi]");
    writeln("    mul  bx");
    writeln("    inc  ch");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  ebx, 4");
    writeln("  mul  bx");
    writeln("  inc  eax");
    writeln("  push eax");
    writeln("  invoke realloc, dword ptr [esi], eax");
    writeln("  pop  ebx");
    writeln("  pop  esi");
    writeln("  mov  [esi], eax");      /* ESI points to array of pointers */
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("redimarray endp");
    writeln("; =========================================================================");
}
/*---------- end func_redimarray ----------*/



void func_freeArray()
{                            /* enters: ESI = array base address */
    writeln("; --------------------------------------------------");
    writeln("freeArray proc");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, [esi]");
    writeln("  .if eax == 0");
    writeln("    jmp freearry_end");   /* array is free */
    writeln("  .endif");
    writeln("  push esi");             /* save the array pointer */
    writeln("  mov  edi, esi");
    writeln("  add  edi, 4");          /* this is the param count */
    writeln("  mov  cx, word ptr [edi]");
    writeln("  dec  cx");
    writeln("  mov  ch, 0");
    writeln("  add  edi, 2");
    writeln("  xor  eax, eax");
    writeln("  mov  ax, word ptr [edi]");
    writeln("@@:");
    writeln("  .if ch < cl");
    writeln("    add  edi, 2");
    writeln("    mov  bx, word ptr [edi]");
    writeln("    mul  bx");
    writeln("    inc  ch");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  xor  ecx, ecx");
    writeln("  mov  ebx, eax");
    writeln("  pop  esi");
    writeln("  push esi");
    writeln("  mov  edi, [esi]");
    writeln("@@:");
    writeln("  .if ecx < ebx");
    writeln("    mov  eax, [edi]");
    writeln("    .if eax != 0");
    writeln("      pushad");
    writeln("      invoke free, eax");
    writeln("      popad");
    writeln("    .endif");
    writeln("    add  edi, 4");
    writeln("    inc  ecx");
    writeln("    jmp @B");
    writeln("  .endif");
    writeln("  pop  esi");
    writeln("  push esi");
    writeln("  mov  edi, [esi]");
    writeln("  invoke free, edi");
    writeln("  pop  esi");
    writeln("  mov  [esi], dword ptr 0");
    writeln("freearry_end:");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("freeArray endp");
    writeln("; =========================================================================");
}
/*---------- end func_freeArray ----------*/



void func_quadArryElement()
{                            /* enters: EDI = this element's address */
    writeln("; --------------------------------------------------");
    writeln("quadArryElement proc");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  mov  eax, [edi]");
    writeln("  .if eax != 0");
    writeln("    invoke free, eax");
    writeln("  .endif");
    writeln("  mov  eax, 8");
    writeln("  invoke malloc, eax");
    writeln("  pop  edi");
    writeln("  mov  [edi], eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("quadArryElement endp");
    writeln("; =========================================================================");
}
/*---------- end func_quadArryElement ----------*/



void func_dblArryElement()
{                            /* enters: EDI = this element's address */
    writeln("; --------------------------------------------------");
    writeln("dblArryElement proc");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  mov  eax, [edi]");
    writeln("  .if eax != 0");
    writeln("    invoke free, eax");
    writeln("  .endif");
    writeln("  mov  eax, 4");
    writeln("  invoke malloc, eax");
    writeln("  pop  edi");
    writeln("  mov  [edi], eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("dblArryElement endp");
    writeln("; =========================================================================");
}
/*---------- end func_dblArryElement ----------*/



void func_getArryOffst()
{                  /* enters: ESI = array base address, ESI = params address */
    writeln("; --------------------------------------------------");
    writeln("getArryOffst proc");
    writeln("; --------------------------------------------------");
    writeln("  xor  eax, eax");
    writeln("  xor  ecx, ecx");
    writeln("@@:");
    writeln("  mov  cx, word ptr [esi]");
    writeln("  .if cx != 0");
    writeln("    add  edi, 2");
    writeln("    mov  bx, word ptr [edi]");
    writeln("    dec  cx");
    writeln("    add  eax, ecx");
    writeln("    mul  bx");
    writeln("    add  esi, 2");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  add  esi, 2");
    writeln("  mov  cx, word ptr [esi]");
    writeln("  dec  cx");
    writeln("  add  eax, ecx");
    writeln("  mov  ebx, 4");
    writeln("  mul  bx");              /* EAX = offset */
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("getArryOffst endp");
    writeln("; =========================================================================");
}
/*---------- end func_getArryOffst ----------*/



void func_dimstrarray()
{                            /* enters: ESI = pointer address */
    writeln("; --------------------------------------------------");
    writeln("dimstrarray proc");
    writeln("; --------------------------------------------------");
    writeln("  push esi");
    writeln("  mov  edi, esi");
    writeln("  add  edi, 4");
    writeln("  mov  cx, word ptr [edi]");
    writeln("  dec  cx");
    writeln("  mov  ch, 0");
    writeln("  add  edi, 2");
    writeln("  mov  ax, word ptr [edi]");
    writeln("@@:");
    writeln("  .if ch < cl");
    writeln("    add  edi, 2");
    writeln("    mov  bx, word ptr [edi]");
    writeln("    mul  bx");
    writeln("    inc  ch");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  ebx, 4");
    writeln("  mul  bx");
    writeln("  inc  eax");
    writeln("  push eax");
    writeln("  invoke malloc, eax");
    writeln("  pop  ebx");
    writeln("  pop  esi");
    writeln("  mov  [esi], eax");      /* ESI points to array of pointers */
    writeln("  invoke memset, eax, 0, ebx");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("dimstrarray endp");
    writeln("; =========================================================================");
}
/*---------- end func_dimstrarray ----------*/



void func_setcolortext()
{
    writeln("; --------------------------------------------------");
    writeln("setcolortext proc");      /* enters: EAX=foregrnd, EBX=bkgrnd */
    writeln("; --------------------------------------------------");
    writeln("  mov  ecx, eax");
    writeln("  mov  eax, 16");
    writeln("  mul  bx");
    writeln("  or   eax, ecx");
    writeln("  invoke SetConsoleTextAttribute, hStdHandle, eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("setcolortext endp");
    writeln("; =========================================================================");
}
/*---------- end func_setcolortext ----------*/



void func_getfilelength()
{
    writeln("; --------------------------------------------------");
    writeln("getfilelength proc ");    /* enters: EAX = (fptr) */
    writeln("; --------------------------------------------------");
    writeln("  call getfilehandle");
    writeln("  push eax");             /* save File PTR */
    writeln("  invoke ftell, eax");    /* get current offset */
    writeln("  mov  ecx, eax");        /* and save it */
    writeln("  pop  eax");             /* load fptr */
    writeln("  push ecx");             /* save current offset */
    writeln("  push eax");             /* save File PTR */
    writeln("  invoke fseek, eax, 0, SEEK_END");
    writeln("  pop  eax");             /* load fptr */
    writeln("  push eax");             /* save File PTR */
    writeln("  invoke ftell, eax");
    writeln("  mov  iLVAR, eax");      /* integer value is in eax */
    writeln("  FILD iLVAR");
    writeln("  pop  eax");             /* load fptr */
    writeln("  pop  ecx");             /* reload current offset */
    writeln("  invoke fseek, eax, ecx, SEEK_SET");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("getfilelength endp");
    writeln("; =========================================================================");
}
/*---------- end func_getfilelength ----------*/



void func_readQintstr()
{                  /* extract a quad integer value from a file INPUT or READ */
    writeln("; --------------------------------------------------");
    writeln("readQintstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  FLDZ");
    writeln("  FISTP qword ptr [edi]");
    writeln("  mov  edi, offset FltString");
    writeln("  push edi");
    writeln("  xor  eax, eax");
    writeln("@@:");
    writeln("  mov  al, byte ptr [esi]");
    writeln("  .if al != ',' && al != 10 && al != 0");
    writeln("    mov  [edi], al");
    writeln("    mov  [esi], ah");
    writeln("    inc  esi");
    writeln("    inc  edi");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  [edi], ah");       /* add '\0' terminator */
    writeln("  inc  esi");
    writeln("  mov  integer, esi");
    writeln("  pop  eax");
    writeln("  pop  edi");
    writeln("  push edi");
    writeln("  invoke StrToFloat, eax, edi");
    writeln("  pop  edi");
    writeln("  FLD qword ptr [edi]");
    writeln("  FISTP qword ptr [edi]");
    writeln("  mov  esi, integer");    /* ESI = iobuffer address */
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("readQintstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_readQintstr ----------*/



void func_readfltstr()
{                       /* extract a float value from a file INPUT or READ */
    writeln("; --------------------------------------------------");
    writeln("readfltstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  FLDZ");
    writeln("  FSTP qword ptr [edi]");
    writeln("  mov  edi, offset FltString");
    writeln("  push edi");
    writeln("  xor  eax, eax");
    writeln("@@:");                    /* integer number */
    writeln("  mov  al, byte ptr [esi]");
    writeln("  .if al != ',' && al != 10 && al != 0 && al != '.'");
    writeln("    mov  [edi], al");
    writeln("    mov  [esi], ah");
    writeln("    inc  esi");
    writeln("    inc  edi");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  .if al == '.'");
    writeln("@@:");                    /* fractional number */
    writeln("    mov  al, byte ptr [esi]");
    writeln("    .if al != ',' && al != 10 && al != '0'");
    writeln("      mov  [edi], al");
    writeln("      mov  [esi], ah");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("  .endif");
    writeln("  .if al == '0'");
    writeln("@@:");                    /* trailing zeros */
    writeln("    mov  al, byte ptr [esi]");
    writeln("    .if al != ',' && al != 10");
    writeln("      mov  [esi], ah");
    writeln("      inc  esi");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("  .endif");
    writeln("  mov  [edi], ah");       /* add '\0' terminator */
    writeln("  inc  esi");
    writeln("  mov  integer, esi");
    writeln("  pop  eax");
    writeln("  pop  edi");
    writeln("  invoke StrToFloat, eax, edi");
    writeln("  mov  esi, integer");    /* ESI = iobuffer address */
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("readfltstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_readfltstr ----------*/



void func_readintstr()
{                  /* extract an integer value from a file INPUT or READ */
    writeln("; --------------------------------------------------");
    writeln("readintstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  push edi");
    writeln("  FLDZ");
    writeln("  FISTP dword ptr [edi]");
    writeln("  mov  edi, offset IntString");
    writeln("  push edi");
    writeln("  xor  eax, eax");
    writeln("@@:");
    writeln("  mov  al, byte ptr [esi]");
    writeln("  .if al != ',' && al != 10 && al != 0");
    writeln("    mov  [edi], al");
    writeln("    mov  [esi], ah");
    writeln("    inc  esi");
    writeln("    inc  edi");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  [edi], ah");       /* add '\0' terminator */
    writeln("  inc  esi");
    writeln("  mov  integer, esi");
    writeln("  pop  eax");
    writeln("  invoke atodw, eax");
    writeln("  pop  edi");
    writeln("  mov  [edi], eax");
    writeln("  mov  esi, integer");    /* ESI = iobuffer address */
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("readintstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_readintstr ----------*/



void func_movstrng_bffr()
{                  /* extract a character string from a file INPUT or READ */
    writeln("; --------------------------------------------------");
    writeln("movstrng_bffr proc ");    /* enter: ESI=buffer, EDI=destination */
    writeln("; --------------------------------------------------");
    writeln("  call clearstrng_bffr");
    writeln("  push eax");             /* push string address */
    writeln("  mov  edi, eax");
    writeln("  xor  eax, eax");
    writeln("@@:");
    writeln("  mov  al, byte ptr [esi]");
    writeln("  .if al != ',' && al != 10 && al != 0");
    writeln("    mov  [edi], al");
    writeln("    mov  [esi], ah");
    writeln("    inc  esi");
    writeln("    inc  edi");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  [edi], ah");       /* add '\0' terminator */
    writeln("  inc  esi");
    writeln("  mov  integer, esi");
    writeln("  pop  eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("movstrng_bffr endp");
    writeln("; =========================================================================");
}
/*---------- end func_movstrng_bffr ----------*/



void func_clearfltvar()
{
    writeln("; --------------------------------------------------");
    writeln("clearfltvar proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], eax");
    writeln("  add  esi, 4");
    writeln("  mov  [esi], eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("clearfltvar endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearfltvar ----------*/



void func_clearintvar()
{
    writeln("; --------------------------------------------------");
    writeln("clearintvar proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("clearintvar endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearintvar ----------*/



void func_clearstrvar()
{
    writeln("; --------------------------------------------------");
    writeln("clearstrvar proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, [esi]\t\t\t; clear string variable");
    writeln("  .if edi != 0");
    writeln("    pushad");
    writeln("    invoke free, edi");
    writeln("    popad");
    writeln("    mov  eax, 0");
    writeln("    mov  [esi], eax");
    writeln("  .endif");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("clearstrvar endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearstrvar ----------*/



void func_clear_allvars()
{
    writeln("; --------------------------------------------------");
    writeln("clear_allvars proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  esi, _var_start");
    writeln("  mov  edi, _int_start\t\t; clear strings");
    writeln("  mov  ecx, 0");
    writeln("  add  esi, 4");
    writeln("@@:");
    writeln("  .if esi < edi");
    writeln("    mov  eax, [esi]");
    writeln("    .if eax != 0");
    writeln("      pushad");
    writeln("      invoke free, eax");
    writeln("      popad");
    writeln("      mov  [esi], ecx");
    writeln("    .endif");
    writeln("    add  esi, 4");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  edi, _flt_start\t\t; clear integers");
    writeln("  add  esi, 4");
    writeln("@@:");
    writeln("  .if esi < edi");
    writeln("    mov  [esi], ecx");
    writeln("    add  esi, 4");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  mov  edi, _var_endzz\t\t; clear floats");
    writeln("  add  esi, 4");
    writeln("@@:");
    writeln("  .if esi < edi");
    writeln("    mov  [esi], ecx");
    writeln("    add  esi, 4");
    writeln("    mov  [esi], ecx");
    writeln("    add  esi, 4");
    writeln("    jmp  @B");
    writeln("  .endif");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("clear_allvars endp");
    writeln("; =========================================================================");
}
/*---------- end func_clear_allvars ----------*/



void func_rsetstr()
{
    writeln("; --------------------------------------------------");
    writeln("rsetstr proc");      /* enter with: EDX = [field length] */
    writeln("; --------------------------------------------------");
    writeln("  pushad");
    writeln("  invoke strlen, esi        ; get source length");
    writeln("  mov  iLVAR, eax");
    writeln("  popad");
    writeln("  mov  eax, iLVAR");
    writeln("  dec  edx");
    writeln(";===========================");
    writeln("  .if eax >= edx            ; if source >= destination");
    writeln("    mov  ecx, 0");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  al, byte ptr [esi]");
    writeln("      mov  [edi], al");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln(";===========================");
    writeln("  .elseif eax < edx");
    writeln("    push edx");
    writeln("    sub  edx, eax");
    writeln("    mov  ebx, edx");
    writeln("    mov  ecx, 0");
    writeln("    mov  eax, 32");
    writeln("@@:");
    writeln("    .if ecx < ebx");
    writeln("      mov  [edi], al");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("    xor  eax, eax");
    writeln("    pop  edx");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  al, byte ptr [esi]");
    writeln("      mov  [edi], al");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("  .endif");
    writeln(";===========================");
    writeln("  xor  eax, eax");
    writeln("  mov  [edi], al");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("rsetstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_rsetstr ----------*/



void func_lsetstr()
{
    writeln("; --------------------------------------------------");
    writeln("lsetstr proc");      /* enter with: EDX = [field length] */
    writeln("; --------------------------------------------------");
    writeln("  pushad");
    writeln("  invoke strlen, esi        ; get source length");
    writeln("  mov  iLVAR, eax");
    writeln("  popad");
    writeln("  mov  eax, iLVAR");
    writeln("  dec  edx");
    writeln(";===========================");
    writeln("  .if eax >= edx            ; if source >= destination");
    writeln("    mov  ecx, 0");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  al, byte ptr [esi]");
    writeln("      mov  [edi], al");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln(";===========================");
    writeln("  .elseif eax < edx");
    writeln("    push edx");
    writeln("    mov  edx, eax");
    writeln("    mov  ecx, 0");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  al, byte ptr [esi]");
    writeln("      mov  [edi], al");
    writeln("      inc  esi");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("    pop edx");
    writeln("    mov  al, 32");
    writeln("@@:");
    writeln("    .if ecx < edx");
    writeln("      mov  [edi], al");
    writeln("      inc  edi");
    writeln("      inc  ecx");
    writeln("      jmp  @B");
    writeln("    .endif");
    writeln("  .endif");
    writeln(";===========================");
    writeln("  xor  eax, eax");
    writeln("  mov  [edi], al");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("lsetstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_lsetstr ----------*/



void func_setupiobuffer()
{
    writeln("; --------------------------------------------------");
    writeln("setupiobuffer proc");
    writeln("; --------------------------------------------------");
    writeln("  push eax");
    writeln("  mov  eax, [edi]");
    writeln("  .if eax != 0");
    writeln("    invoke free, eax");
    writeln("  .endif");
    writeln("  pop  eax");
    writeln("  inc  eax");
    writeln("  invoke malloc, eax");
    writeln("  mov  [edi], eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("setupiobuffer endp");
    writeln("; =========================================================================");
}
/*---------- end func_setupiobuffer ----------*/



void func_clearLngstrng_bffr()
{
    writeln("; --------------------------------------------------");
    writeln("clearLngstrng_bffr proc ");
    writeln("; --------------------------------------------------");
    writeln("  push  esi");            /* enter: ESI = addr varname */
    writeln("  .if edi == 0");         /* EDI = ptr *string */
    writeln("    mov  eax, BUFSIZE");
    writeln("    invoke malloc, eax");
    writeln("  .else");
    writeln("    push edi");
    writeln("    invoke _msize, edi");
    writeln("    pop  edi");
    writeln("    .if eax < BUFSIZE");
    writeln("      invoke realloc, edi, BUFSIZE");
    writeln("    .else");
    writeln("      mov  eax, edi");
    writeln("    .endif");
    writeln("  .endif");
    writeln("  pop  esi");
    writeln("  mov  [esi], eax");
    writeln("  ret");                  /* exit: EAX = ptr *string */
    writeln("; --------------------------------------------------");
    writeln("clearLngstrng_bffr endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearLngstrng_bffr ----------*/



void func_clearstrng_bffr()
{
    writeln("; --------------------------------------------------");
    writeln("clearstrng_bffr proc ");
    writeln("; --------------------------------------------------");
    writeln("  .if edi != 0");
    writeln("    invoke free, edi");
    writeln("  .endif");
    writeln("  invoke malloc, BUFFR_SIZ");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("clearstrng_bffr endp");
    writeln("; =========================================================================");
}
/*---------- end func_clearstrng_bffr ----------*/



void func_getfilehandle()
{
    writeln("; --------------------------------------------------");
    writeln("getfilehandle proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  ebx, 4");
    writeln("  mul  bl");
    writeln("  mov  edi, offset iohandles");
    writeln("  add  edi, eax");
    writeln("  mov  eax, [edi]");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("getfilehandle endp");
    writeln("; =========================================================================");
}
/*---------- end func_getfilehandle ----------*/



void func_closeafile()
{
    writeln("; --------------------------------------------------");
    writeln("closeafile proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset iohandles");
    writeln("  mov  esi, offset iobuffers");
    writeln("  mov  ebx, 4");
    writeln("  mul  bl");
    writeln("  push eax");
    writeln("  add  edi, eax");
    writeln("  mov  eax, [edi]");
    writeln("  invoke fclose, eax");
    writeln("  mov  eax, 0");
    writeln("  mov  [edi], eax");
    writeln("  pop  eax");
    writeln("  add  esi, eax");
    writeln("  mov  eax, [esi]");
    writeln("  invoke free, eax");
    writeln("  mov  eax, 0");
    writeln("  mov  [esi], eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("closeafile endp");
    writeln("; =========================================================================");
}
/*---------- end func_closeafile ----------*/



void func_closeallfiles()
{
    writeln("; --------------------------------------------------");
    writeln("closeallfiles proc ");
    writeln("; --------------------------------------------------");
    writeln("  call _fcloseall");
    writeln("  mov  edi, offset iohandles");
    writeln("  mov  esi, offset iobuffers");
    writeln("  mov  ecx, 98");
    writeln("  xor  ebx, ebx");
    writeln("  xor  eax, eax");
    writeln("close_all:");
    writeln("  .if ebx <= ecx");
    writeln("    mov  edx, [edi]");
    writeln("    .if edx != 0");
    writeln("      mov  [edi], eax");
    writeln("      mov  edx, [esi]");
    writeln("      pushad");
    writeln("      invoke free, edx");
    writeln("      popad");
    writeln("      mov  [esi], eax");
    writeln("    .endif");
    writeln("    add  edi, 4");
    writeln("    add  esi, 4");
    writeln("    inc  ebx");
    writeln("    jmp  close_all");
    writeln("  .endif");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("closeallfiles endp");
    writeln("; =========================================================================");
}
/*---------- end func_closeallfiles ----------*/



void func_timestr()
{
    writeln("; --------------------------------------------------");
    writeln("timestr proc ");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  colon[2]:BYTE");
    writeln("; --------------------------------------------------");
    writeln("  mov  colon, byte ptr 58");
    writeln("  mov  colon+1, byte ptr 0");
    writeln("  call get_sys_time");
    writeln("  mov  edi, offset BffrInput");
    writeln("  FILD  iHour");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcpy, edi, addr IntString");
    writeln("  invoke strcat, edi, addr colon");
    writeln("  FILD  iMinute");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  invoke strcat, edi, addr colon");
    writeln("  FILD  iSecond");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  invoke strcat, edi, addr colon");
    writeln("  FILD  iMilli");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("timestr endp");
    writeln("; =========================================================================");
}
/*---------- end func_timestr ----------*/



void func_datestr()
{
    writeln("; --------------------------------------------------");
    writeln("datestr proc ");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  slash[2]:BYTE");
    writeln("; --------------------------------------------------");
    writeln("  mov  slash, byte ptr 47");
    writeln("  mov  slash+1, byte ptr 0");
    writeln("  call get_sys_date");
    writeln("  mov  edi, offset BffrInput");
    writeln("  FILD  iMonth");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcpy, edi, addr IntString");
    writeln("  invoke strcat, edi, addr slash");
    writeln("  FILD  iDay");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  invoke strcat, edi, addr slash");
    writeln("  FILD  iYear");
    writeln("  FISTP  integer");
    writeln("  invoke dwtoa, integer, addr IntString");
    writeln("  invoke strcat, edi, addr IntString");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("datestr endp");
    writeln("; =========================================================================");
}
/*---------- end func_datestr ----------*/



void func_getsysdate()
{
    writeln("; =========================================================================");
    writeln("get_sys_date  proc");
    writeln("  ; --------------------------------------------------");
    writeln("  invoke  GetLocalTime, addr system_time               ;Get Local Time");
    writeln("  xor  eax, eax");
    writeln("  mov  ax, system_time.wYear");
    writeln("  mov  iYear, eax");
    writeln("  mov  ax, system_time.wMonth");
    writeln("  mov  iMonth, eax");
    writeln("  mov  ax, system_time.wDay");
    writeln("  mov  iDay, eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("get_sys_date  endp");
    writeln("; =========================================================================");
}
/*---------- end func_getsysdate ----------*/



void func_getsystime()
{
    writeln("; =========================================================================");
    writeln("get_sys_time  proc");
    writeln("  ; --------------------------------------------------");
    writeln("  invoke  GetLocalTime, addr system_time               ;Get Local Time");
    writeln("  xor  eax, eax");
    writeln("  mov  ax, system_time.wHour");
    writeln("  mov  iHour, eax");
    writeln("  mov  ax, system_time.wMinute");
    writeln("  mov  iMinute, eax");
    writeln("  mov  ax, system_time.wSecond");
    writeln("  mov  iSecond, eax");
    writeln("  mov  ax, system_time.wMilliseconds");
    writeln("  mov  iMilli, eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("get_sys_time  endp");
    writeln("; =========================================================================");
}
/*---------- end func_getsystime ----------*/



void func_resetcursor()
{
    writeln("; --------------------------------------------------");
    writeln("reset_cursor proc ");
    writeln("; --------------------------------------------------");
    writeln("  invoke strlen, addr BffrInput");
    writeln("  add  iCOL, eax");
    writeln("  invoke locate, iCOL, iROW");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("reset_cursor endp");
    writeln("; =========================================================================");
}
/*---------- end func_resetcursor ----------*/



void func_wherexy()
{
    writeln("; --------------------------------------------------");
    writeln("wherexy proc ");
    writeln("; --------------------------------------------------");
    writeln(".data");
    writeln("\tfname   db  'CONOUT$',0");
    writeln("\tfaccess dd  GENERIC_READ or GENERIC_WRITE");
    writeln("\tfsmode  dd  FILE_SHARE_READ or FILE_SHARE_WRITE");
    writeln("\tfmode   dd  OPEN_EXISTING");
    writeln("\tfattrib dd  0");
    writeln("\tfhtemp  dd  NULL");
    writeln(".data?");
    writeln("\tfsecur  dd  ?");
    writeln("\tfHandle dd  ?");
    writeln("\tfcsbi   dd  ?");
    writeln("\tfcoord  dd  ?");
    writeln(".code");
    writeln("  mov  eax, sa.bInheritHandle");
    writeln("  mov  fsecur, eax");
    writeln("  lea  eax, csbi");
    writeln("  mov  fcsbi, eax");
    writeln("  invoke CreateFile, addr fname, faccess, fsmode, fsecur, fmode, fattrib, fhtemp");
    writeln("  mov  fHandle, eax");
    writeln("  invoke GetConsoleScreenBufferInfo, fHandle, fcsbi");
    writeln("  .if eax == -1");
    writeln("    xor  eax, eax");
    writeln("  .else");
    writeln("    mov  eax, csbi.dwCursorPosition");
    writeln("  .endif");
    writeln("  mov  fcoord, eax");
    writeln("  invoke CloseHandle, fHandle");
    writeln("  loWORD  fcoord");
    writeln("  mov  iCOL, eax");
    writeln("  hiWORD  fcoord");
    writeln("  mov  iROW, eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("wherexy endp");
    writeln("; =========================================================================");
}
/*---------- end func_wherexy ----------*/



void func_mkqstr()
{
    writeln("; --------------------------------------------------");
    writeln("mkqstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  FILD qword ptr [esi]");
    writeln("  FISTP qword ptr [edi]");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("mkqstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_mkqstr ----------*/



void func_mkistr()
{
    writeln("; --------------------------------------------------");
    writeln("mkistr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, [esi]");
    writeln("  mov  [edi], eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("mkistr endp");
    writeln("; =========================================================================");
}
/*---------- end func_mkistr ----------*/



void func_mkdstr()
{
    writeln("; --------------------------------------------------");
    writeln("mkdstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  FLD qword ptr [esi]");
    writeln("  FSTP qword ptr [edi]");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("mkdstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_mkdstr ----------*/



void func_inputstr()
{
    writeln("; --------------------------------------------------");
    writeln("inputstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL   ndx :DWORD");
    writeln("  LOCAL count :DWORD");
    writeln("  LOCAL   chr :BYTE");
    writeln("  LOCAL  buff :DWORD");
    writeln("; --------------------------------------------------");
    writeln("  mov  count, eax");
    writeln("  mov  edi, offset BffrInput");
    writeln("  mov  buff, edi");
    writeln("  mov  ndx, 0");
    writeln("  ;");
    writeln("inputstr1:");
    writeln("  mov  eax, ndx");
    writeln("  .if (eax < count)");
    writeln("    call _getche");
    writeln("    mov  chr, al");
    writeln("    mov  edi, buff");
    writeln("    .if (chr > 31) && (chr < 127)");
    writeln("       mov  al, chr");
    writeln("       add  edi, ndx");
    writeln("       mov  [edi], al");
    writeln("       add  ndx, 1");
    writeln("    .elseif (chr==8) && (ndx>0)");
    writeln("       add  edi, ndx");
    writeln("       mov  [edi], byte ptr 0");
    writeln("       sub  ndx, 1");
    writeln("    .elseif (chr==13)");
    writeln("       add  edi, ndx");
    writeln("       mov  [edi], byte ptr 0");
    writeln("       mov  eax, count");
    writeln("       mov  ndx, eax");
    writeln("    .endif");
    writeln("    jmp inputstr1");
    writeln("  .endif");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("inputstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_inputstr ----------*/



void func_inkeystr()
{
    writeln("; --------------------------------------------------");
    writeln("inkeystr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  mov  [edi], byte ptr 0");
    writeln("  call _kbhit");          /* call _kbhit    */
    writeln("  .if eax != 0");         /* if eax != NULL */
    writeln("    call _getch");        /* call _getch    */
    writeln("    .if eax == 0");       /* if eax == NULL */
    writeln("      mov  edi, offset BffrInput");
    writeln("      mov  [edi], byte ptr 32");    /* add a space    */
    writeln("      call _getch");                /* call _getch again */
    writeln("      mov  edi, offset BffrInput");
    writeln("      mov  [edi+1], al");
    writeln("      mov  [edi+2], byte ptr 0");
    writeln("    .else");
    writeln("      mov  edi, offset BffrInput");
    writeln("      mov  [edi], al");
    writeln("      mov  [edi+1], byte ptr 0");
    writeln("    .endif");
    writeln("  .endif");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("inkeystr endp");
    writeln("; =========================================================================");
}
/*---------- end func_inkeystr ----------*/



void func_stringstr()
{
    writeln("; --------------------------------------------------");
    writeln("stringstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  push eax");
    writeln("  invoke memset, edi, ebx, eax");
    writeln("  pop  eax");
    writeln("  mov  esi, offset BffrInput");
    writeln("  mov  [esi+eax], byte ptr 0");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("stringstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_stringstr ----------*/



void func_strsFval()
{
    writeln("; --------------------------------------------------");
    writeln("strsFval proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset FltString");
    writeln("  mov  esi, offset format");
    writeln("  invoke sprintf, edi, esi, x87buff");
    writeln("  mov  esi, offset FltString");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("strsFval endp");
    writeln("; =========================================================================");
}
/*---------- end func_strsFval ----------*/



void func_strsIval()
{
    writeln("; --------------------------------------------------");
    writeln("strsIval proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset IntString");
    writeln("  invoke _ltoa, integer, edi, 10");
    writeln("  mov  esi, offset IntString");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("strsIval endp");
    writeln("; =========================================================================");
}
/*---------- end func_strsIval ----------*/



void func_spacestr()
{
    writeln("; --------------------------------------------------");
    writeln("spacestr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  mov  ebx, 32");
    writeln("  push eax");
    writeln("  invoke memset, edi, ebx, eax");
    writeln("  pop  eax");
    writeln("  mov  esi, offset BffrInput");
    writeln("  mov  [esi+eax], byte ptr 0");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("spacestr endp");
    writeln("; =========================================================================");
}
/*---------- end func_spacestr ----------*/



void func_midstr()
{
    writeln("; --------------------------------------------------");
    writeln("mid_str proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  invoke szMid, esi, edi, ebx, eax");
    writeln("  mov  [edi+eax], byte ptr 0");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("mid_str endp");
    writeln("; =========================================================================");
}
/*---------- end func_midstr ----------*/



void func_rightstr()
{
    writeln("; --------------------------------------------------");
    writeln("rightstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  invoke szRight, esi, edi, eax");
    writeln("  mov  [edi+eax], byte ptr 0");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("rightstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_rightstr ----------*/



void func_leftstr()
{
    writeln("; --------------------------------------------------");
    writeln("leftstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  edi, offset BffrInput");
    writeln("  invoke szLeft, esi, edi, eax");
    writeln("  mov  [edi+eax], byte ptr 0");
    writeln("  mov  esi, offset BffrInput");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("leftstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_leftstr ----------*/



void func_chrstr()
{
    writeln("; --------------------------------------------------");
    writeln("chrstr proc ");
    writeln("; --------------------------------------------------");
    writeln("  mov  esi, offset BffrInput");
    writeln("  mov  [esi], byte ptr al");
    writeln("  mov  [esi+1], byte ptr 0");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("chrstr endp");
    writeln("; =========================================================================");
}
/*---------- end func_chrstr ----------*/



void copystrng_bffr()
{                            /* enter: EDI = string base address */
    writeln("; --------------------------------------------------");
    writeln("copystrng_bffr proc ");
    writeln("; --------------------------------------------------");
    writeln("  .if edi != 0");
    writeln("    invoke free, edi");
    writeln("  .endif");
    writeln("  invoke strlen, addr StringBffr");
    writeln("  inc  eax");
    writeln("  invoke malloc, eax");
    writeln("  push eax");
    writeln("  invoke strcpy, eax, addr StringBffr");
    writeln("  pop  eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("copystrng_bffr endp");
    writeln("; =========================================================================");
    writeln("; --------------------------------------------------");
    writeln("copystrng proc ");
    writeln("; --------------------------------------------------");
    write_str("  invoke strcpy, addr StringBffr, esi");
    writeln("\t\t; copy into buffer");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("copystrng endp");
    writeln("; =========================================================================");
    writeln("catstrng proc ");
    writeln("; --------------------------------------------------");
    write_str("  invoke strcat, addr StringBffr, esi");
    writeln("\t\t; stringcat into buffer");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("catstrng endp");
    writeln("; =========================================================================");
}
/*---------- end copystrng_bffr ----------*/



void Do_print()
{   char ch, varname[VAR_NAME];
    int pi, type, mark, len;

/* printf("Doprint::%s", p_string); /**/

    len = strlen(p_string);
    pi = e_pos;
    pi = iswhiter(pi);
    ch = p_string[pi];

    if(ch == '#')                 /* print to file output */
    {
        e_pos = pi;
        print_file(len);
        return;
    }

    e_pos = pi;

    if(strchr(":\n", ch))         /* --- print newline --- */
    {
        writeln("  printstr lf");
        return;
    }

    while((pi < len) && (strchr("\n\0", ch) == 0))
    {
   /* printf("ch=%c pi=%d len=%d\n", ch, pi, len); /**/

        if(isdigit(ch))           /* process a string function */
        {
            prn_function(len);
            pi = e_pos;
            ch = p_string[pi];
            pi++;
        }
        else
        {
            strcpy(varname, "VARX");
            s_pos = pi;
            mark = find_strng(varname);
            mark--;

            if((mark >= 0) && (mark == pi))
            {
                mark = 1;
            }
            else
            {
                mark = 0;
            }

            strcpy(varname, get_varname());
            type = get_ObjectType(varname);      /* object type specifier */
            pi = e_pos;

      /* ch = p_string[pi]; */
      /* printf("name=%s type=%d ch=>%c< pi=%d\n", varname, type, ch, pi); */

            if(type == 0)              /* write string variable */
            {
                write_str(indent);

                if(mark == 0)          /* a regular string variable */
                {
                    write_str("  mov  eax, [");
                    write_str(varname);
                    writeln("]");
                    writeln("  .if eax != 0");
                    write_str(indent);
                    writeln("    printvar eax");
                    writeln("  .endif");
                }
                else                   /* a temp string variable */
                {
                    write_str("  printstr ");
                    writeln(varname);
                }
            }
            else if(type == 6)         /* write string variable */
            {
                prn_strarry(varname, len);
                pi = e_pos;
                pi++;
            }
            else
            {
                pi = s_pos;            /* push pointer back */
                e_pos = pi;
                prn_expression();      /* variable or math expression */
                pi = e_pos;
                ch = p_string[pi];

                while(strchr("$)", ch) != 0)     /* is it end of statement */
                {
                    pi++;
                    ch = p_string[pi];
                }
            }
        }

        pi = iswhiter(pi);
        ch = p_string[pi];

   /* printf("ch=%c pi=%d\n", ch, pi); /**/

        if(ch == ',')
        {
            writeln("  printstr tab");
        }
        else if(strchr(":\n", ch) != 0)
        {
            write_str(indent);
            writeln("  printstr lf");
        }

        if(strchr("\n\0", ch) == 0)    /* is it end of statement */
        {
            pi++;
            pi = iswhiter(pi);
            ch = p_string[pi];
            e_pos = pi;
        }
   /* printf("ch=%c pi=%d\n", ch, pi); /**/

    }
}
/*---------- end Do_print ----------*/



void prn_expression()
{

    writeln("; --------------------------------------------------");
    writeln("  FINIT \t\t\t; initialize x87");

    a_Expression();               /* call: recursive descent parser */

    write_str("  FSTP  x87buff");
    writeln("\t\t\t; store in print buffer");
    writeln("  invoke FloatToStr2, x87buff, addr FltString");
    writeln("  printstr FltString");
}
/*---------- end prn_expression ----------*/



void prn_strarry(char *name, int len)  /* print an array string */
{   char varname[VAR_NAME];
    int pi, xcnt;


    strcpy(varname, name);        /* enter: array$(n,...) */

    pi = e_pos;
    pi = get_paren(pi, len);
    xcnt = get_ObjectParm(varname);

    writeln("; --------------------------------------------------");

    get_offset(varname, len, xcnt);

    writeln("  mov  eax, [edi]");      /* load string address to EAX */
    writeln("  .if eax != 0");
    writeln("    printvar eax");
    writeln("  .endif");

}
/*---------- end prn_strarry ----------*/



void prn_function(int len)
{   int type;


    type = (int) get_avalue();
    string_functions(len, type);

    if(type == 6)
    {
        writeln("  printstr IntString");
    }
    else
    {
        writeln("  printstr BffrInput");
    }
}
/*---------- end prn_function ----------*/



void Do_beep()
{
    writeln("  invoke Beep, 800, 250");
    /*	dwFreq,	// sound frequency, in hertz
        dwDuration 	// sound duration, in milliseconds
    */
}
/*---------- end Do_beep ----------*/



void Do_cls()           /* call clear-screen */
{
    writeln("  cls");
}
/*---------- end Do_cls ----------*/



void Do_end()           /* jump to Done */
{
    if(showwindow == 1)
    {
        writeln("  .WHILE TRUE");
        writeln("      invoke GetMessage, addr msg, NULL,0,0");
        writeln("      .BREAK .IF(!eax)");
        writeln("          invoke TranslateMessage, addr msg");
        writeln("          invoke DispatchMessage, addr msg");
        writeln("  .ENDW");
        writeln("  mov  eax, msg.wParam");
    }

    writeln("  jmp  DONE");
}
/*---------- end Do_end ----------*/



void Do_goto()
{   char temp[LLEN];


    strcpy(temp, get_varname());

    write_str("  jmp  ");    /* --- write assembly --- */
    writeln(temp);
}
/*---------- end Do_goto ----------*/



void Do_label()
{   char temp[LLEN];


    strcpy(temp, label_nam[line_ndx]);
    PostLabel(temp);
}
/*---------- end Do_label ----------*/



void Do_gosub()
{   char temp[LLEN];

    strcpy(temp, get_varname());

    write_str("  call ");    /* --- write assembly --- */
    writeln(temp);
}
/*---------- end Do_gosub ----------*/



void Do_return()
{
    writeln("  ret");
    writeln("; --------------------------------------------------");
}
/*---------- end Do_return ----------*/



void Do_locate()
{   char rows[VAR_NAME], cols[VAR_NAME];
    int pi, len, ab_code=3, x=line_ndx;


    len = strlen(p_string);
    pi = e_pos;
    pi = get_alpha(pi, len);
    e_pos = pi;

    if(pi < len)                       /* --- get row --- */
    {
        strcpy(rows, get_varname());   /* varname */
        pi = e_pos;
    }
    else                          /* failed to find alpha/num */
    {
        a_bort(ab_code, x);
    }

    pi = get_alpha(pi, len);      /* comma separates row and column */
    e_pos = pi;

    if(pi < len)                  /* --- get column --- */
    {
        strcpy(cols, get_varname());   /* digit-or-varname */
    }
    else
    {
        a_bort(ab_code, x);
    }

    write_str("  invoke locate, ");    /* --- now position cursor --- */
    write_str(cols);
    write_str(", ");
    write_str(rows);
    writeln("\t\t; locate cursor");
}
/*---------- end Do_locate ----------*/



void Do_initialize()
{
    writeln("; --------------------------------------------------");
    writeln("Do_initialize proc");
    writeln("; --------------------------------------------------");
    writeln("  mov  eax, offset _var_start");
    writeln("  mov  _var_start, eax");
    writeln("  mov  eax, offset _int_start");
    writeln("  mov  _int_start, eax");
    writeln("  mov  eax, offset _flt_start");
    writeln("  mov  _flt_start, eax");
    writeln("  mov  eax, offset _var_endzz");
    writeln("  mov  _var_endzz, eax");
    writeln("  invoke GetStdHandle, STD_OUTPUT_HANDLE");
    writeln("  mov  hStdHandle, eax");
    writeln("  ret");
    writeln("; --------------------------------------------------");
    writeln("Do_initialize endp");
    writeln("; =========================================================================");
}
/*---------- end Do_initialize ----------*/

