/* bxbasm : AFunctW.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */


/* ----- function prototypes ----- */
#include "prototyp.h"




void Do_WinFunctions()
{
    if(newwindow == 1)
    {
        func_newwindow();
        func_GetConslWndHandl();
        func_wndproc();
    }

    if(showwindow == 1)
    {
        func_showwindow();
        func_winguiTable();
    }

    if(drawline == 1)
    {
        func_drawLine();
    }

    if(redrawscreen == 1)
    {
        func_reDraw_Scrn();
    }

    if(drawbox == 1)
    {
        func_DrawBox();
    }

    if(postmessage == 1)
    {
        func_PostMssge();
    }

    if(getgdifont == 1)
    {
        func_getGDIFont();
    }

    if(resetoldfont == 1)
    {
        func_ResetOldFont();
    }

    if(drawrectangle == 1)
    {
        func_DrawRect();
    }

    if(drawroundedrect == 1)
    {
        func_DrawRndRect();
    }

    if(drawsquare == 1)
    {
        func_DrawSquare();
    }

    if(drawellipse == 1)
    {
        func_DrawEllipse();
    }

    if(drawcircle == 1)
    {
        func_DrawCircle();
    }

    if(drawpie == 1)
    {
        func_DrawPie();
    }

    if(drawchord == 1)
    {
        func_DrawChord();
    }

    if(drawarc == 1)
    {
        func_DrawArc();
    }

    if(pixelset == 1)
    {
        func_PixelSet();
    }

    if(textColor == 1)
    {
        func_TextColor();
    }

    if(newpen == 1)
    {
        func_NewPen();
    }

    if(oldpen == 1)
    {
        func_OldPen();
    }

    if(pencolor == 1)
    {
        func_setPenColor();
    }

    if(setbgcolor == 1)
    {
        func_setBGColor();
    }

    if(clearwindow == 1)
    {
        func_ClearWindow();
    }

    if(setbkmode == 1)
    {
        func_setBKMode();
    }

    if(resizewin == 1)
    {
        func_ReSizeWin();
    }

    if(getpoint == 1)
    {
        func_get_Point();
    }

    if(gdicreatepen == 1)
    {
        func_gdiCreatePen();
    }

    if(gdilogbrush == 1)
    {
        func_gdiLogBrush();
    }

    if(createbrushind == 1)
    {
        func_gdiCreateBrushInd();
    }

    if(resetoldbrush == 1)
    {
        func_OldBrush();
    }




}
/*------ end Do_WinFunctions ------*/








void func_OldBrush()
{
    writeln("; --------------------------------------------------");
    writeln("gdi_oldbrush  proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke SelectObject, myhDC, glhOldBrush");
    writeln("  invoke DeleteObject, glhNewBrush"); /* remember to clean up */
    writeln(";");
    writeln("  ret");
    writeln("gdi_oldbrush endp");
    writeln("; =========================================================================");

}
/* ------ end func_OldBrush ------ */



void func_gdiCreateBrushInd()     /* wrapper for CreateBrushIndirect() */
{
    writeln("; --------------------------------------------------");
    writeln("gdi_createbrushind  proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  hBrush:HBRUSH");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke CreateBrushIndirect, addr MyLogBrush");
    writeln("  mov hBrush, eax");
    writeln("  mov glhNewBrush, eax");
    writeln("  invoke SelectObject, myhDC, hBrush");
    writeln("  mov glhOldBrush, eax");
    writeln(";");
    writeln("  ret");
    writeln("gdi_createbrushind endp");
    writeln("; =========================================================================");

}
/* ------ end func_gdiCreateBrushInd ------ */



void func_gdiLogBrush()           /* used for CreateBrushIndirect() */
{
    writeln("; --------------------------------------------------");
    write_str("gdi_logbrush  proc  nStyle:DWORD, nPattern:DWORD");
    writeln(", nc1:DWORD, nc2:DWORD, nc3:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  tcolor:DWORD");
    writeln("  LOCAL  rgbR:BYTE");
    writeln("  LOCAL  rgbG:BYTE");
    writeln("  LOCAL  rgbB:BYTE");
    writeln(";");
    writeln("  loWORD nc1 \t\t\t; convert RGB DWORDs to BYTEs");
    writeln("  mov rgbR, al");
    writeln("  loWORD nc2");
    writeln("  mov rgbG, al");
    writeln("  loWORD nc3");
    writeln("  mov rgbB, al");
    writeln("  _RGB rgbR, rgbG, rgbB \t\t; call RGB macro"); // 00ff00ffh
    writeln("  mov tcolor, eax");
    writeln(" ");
    writeln("  assume edi:PTR LOGBRUSH");
    writeln("  mov edi, offset MyLogBrush");
    writeln("  mov eax, nStyle");
    writeln("  mov [edi].lbStyle, eax");
    writeln("  mov eax, nPattern");
    writeln("  mov [edi].lbHatch, eax");
    writeln("  mov eax, tcolor");
    writeln("  mov [edi].lbColor, eax");
    writeln(" ");
    writeln("  assume edi:nothing");
    writeln(";");
    writeln("  ret");
    writeln("gdi_logbrush endp");
    writeln("; =========================================================================");

}
/*---------- end func_gdiLogBrush ----------*/



void func_gdiCreatePen()          /* wrapper for CreatePen() */
{
    writeln("; --------------------------------------------------");
    write_str("gdi_createpen  proc  nStyle:DWORD, nWidth:DWORD");
    writeln(", nc1:DWORD, nc2:DWORD, nc3:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  tcolor:DWORD");
    writeln("  LOCAL  rgbR:BYTE");
    writeln("  LOCAL  rgbG:BYTE");
    writeln("  LOCAL  rgbB:BYTE");
    writeln("  LOCAL  hPen:HPEN");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(" ");
    writeln("  loWORD nc1 \t\t\t; convert RGB DWORDs to BYTEs");
    writeln("  mov rgbR, al");
    writeln("  loWORD nc2");
    writeln("  mov rgbG, al");
    writeln("  loWORD nc3");
    writeln("  mov rgbB, al");
    writeln("  _RGB rgbR, rgbG, rgbB \t\t; call RGB macro"); // 00ff00ffh
    writeln("  mov tcolor, eax");
    writeln(" ");
    writeln("  invoke CreatePen, nStyle, nWidth, tcolor");
    writeln("  mov hPen, eax");
    writeln("  mov glhNewPen, eax");             /* global new pen */
    writeln(" ");
    writeln("  invoke SelectObject, myhDC, hPen");
    writeln("  mov glhOldPen, eax");
    writeln(";");
    writeln("  ret");
    writeln("gdi_createpen endp");
    writeln("; =========================================================================");

}
/* ------ end func_gdiCreatePen ------ */



void func_get_Point()             /* determine the current pixel color */
{
    writeln("; --------------------------------------------------");
    writeln("get_point  proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke GetPixel, myhDC, iLVAR, iRVAR");
    writeln(";");
    writeln("  ret");
    writeln("get_point endp");
    writeln("; =========================================================================");

}
/* ------ end func_get_Point ------ */



void func_ReSizeWin()
{
    writeln("; --------------------------------------------------");
    writeln("resize_win  proc  nx1:DWORD, ny1:DWORD, nx2:DWORD, ny2:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  ndx:BYTE");
    writeln("  LOCAL  xsize1:BYTE");
    writeln("  LOCAL  hwnd:HWND");
    writeln(";");
    writeln("  loWORD iLVAR");    /* this is the index number */
    writeln("  mov ndx, al");
    writeln(" ");
    writeln("  assume edi:PTR WinHwnd");
    writeln("  xor eax, eax");
    writeln("  mov al, ndx");
    writeln("  mov xsize1, sizeof(WinHwnd)");
    writeln("  mul xsize1");
    writeln("  mov edi, offset Winhndl");
    writeln("  add edi, eax");    /* offset Winhndl + (ndx * sizeof(WinHwnd) */
    writeln("  mov eax, [edi].hHandle");
    writeln("  mov hwnd, eax");
    writeln("  assume edi:nothing");
    writeln(";");
    writeln("  invoke MoveWindow, hwnd, nx1, ny1, nx2, ny2, TRUE");
    writeln("  invoke InvalidateRect, hwnd, addr glrect, FALSE");
    writeln("  invoke UpdateWindow, hwnd");
    writeln(" ");
    writeln("  .WHILE TRUE");
    writeln("    invoke PeekMessage, addr msg, NULL, 0, 0, PM_REMOVE");
    writeln("    .BREAK .IF(!eax)");
    writeln("      invoke TranslateMessage, addr msg");
    writeln("      invoke DispatchMessage, addr msg");
    writeln("  .ENDW");
    writeln("  mov  eax, msg.wParam");
    writeln(";");
    writeln("  ret");
    writeln("resize_win endp");
    writeln("; =========================================================================");

}
/* ------ end func_ReSizeWin ------ */



void func_setBKMode()
{
    writeln("; --------------------------------------------------");
    writeln("setbk_mode  proc  ntype:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke SetBkMode, myhDC, ntype");
    writeln(";");
    writeln("  ret");
    writeln("setbk_mode endp");
    writeln("; =========================================================================");

}
/* ------ end func_setBKMode ------ */



void func_ClearWindow()
{
    writeln("; --------------------------------------------------");
    writeln("clear_window  proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  ndx:BYTE");
    writeln("  LOCAL  xsize1:BYTE");
    writeln("  LOCAL  hwnd:HWND");
    writeln("  LOCAL  tcolor:DWORD");
    writeln("  LOCAL  gsObject:HGDIOBJ");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(" ");
    writeln("  invoke GetBkColor, HdcBuffer \t; get the current background color");
    writeln("  mov tcolor, eax");
    writeln("  invoke SetDCBrushColor, myhDC, tcolor");
    writeln("  invoke GetStockObject, DC_BRUSH");
    writeln("  mov gsObject, eax");
    writeln("  invoke FillRect, myhDC, addr glrect, gsObject");
    writeln(" ");
    writeln("  loWORD iLVAR");    /* this is the index number */
    writeln("  mov ndx, al");
    writeln(" ");
    writeln("  assume edi:PTR WinHwnd");
    writeln("  xor eax, eax");
    writeln("  mov al, ndx");
    writeln("  mov xsize1, sizeof(WinHwnd)");
    writeln("  mul xsize1");
    writeln("  mov edi, offset Winhndl");
    writeln("  add edi, eax");    /* offset Winhndl + (ndx * sizeof(WinHwnd) */
    writeln("  mov eax, [edi].hHandle");
    writeln("  mov hwnd, eax");
    writeln("  assume edi:nothing");
    writeln(";");
    writeln("  invoke InvalidateRect, hwnd, addr glrect, FALSE");
    writeln("  invoke UpdateWindow, hwnd");
    writeln("  .WHILE TRUE");
    writeln("    invoke PeekMessage, addr msg, NULL, 0, 0, PM_REMOVE");
    writeln("    .BREAK .IF(!eax)");
    writeln("      invoke TranslateMessage, addr msg");
    writeln("      invoke DispatchMessage, addr msg");
    writeln("  .ENDW");
    writeln("  mov  eax, msg.wParam");
    writeln(";");
    writeln("  ret");
    writeln("clear_window endp");
    writeln("; =========================================================================");

}
/* ------ end func_ClearWindow ------ */



void func_setBGColor()
{
    writeln("; --------------------------------------------------");
    writeln("setbg_color  proc  nc1:DWORD, nc2:DWORD, nc3:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  tcolor:DWORD");
    writeln("  LOCAL  rgbR:BYTE");
    writeln("  LOCAL  rgbG:BYTE");
    writeln("  LOCAL  rgbB:BYTE");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(" ");
    writeln("  loWORD nc1 \t\t\t; convert RGB DWORDs to BYTEs");
    writeln("  mov rgbR, al");
    writeln("  loWORD nc2");
    writeln("  mov rgbG, al");
    writeln("  loWORD nc3");
    writeln("  mov rgbB, al");
    writeln("  _RGB rgbR, rgbG, rgbB \t\t; call RGB macro"); // 00ff00ffh
    writeln("  mov tcolor, eax");
    writeln(" ");
    writeln("  invoke SetBkColor, myhDC, tcolor");
    writeln(";");
    writeln("  ret");
    writeln("setbg_color endp");
    writeln("; =========================================================================");

}
/* ------ end func_setBGColor ------ */



void func_setPenColor()
{
    writeln("; --------------------------------------------------");
    writeln("pen_color  proc  nc1:DWORD, nc2:DWORD, nc3:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  gsObject:HGDIOBJ");
    writeln("  LOCAL  tcolor:DWORD");
    writeln("  LOCAL  rgbR:BYTE");
    writeln("  LOCAL  rgbG:BYTE");
    writeln("  LOCAL  rgbB:BYTE");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(" ");
    writeln("  loWORD nc1 \t\t\t; convert RGB DWORDs to BYTEs");
    writeln("  mov rgbR, al");
    writeln("  loWORD nc2");
    writeln("  mov rgbG, al");
    writeln("  loWORD nc3");
    writeln("  mov rgbB, al");
    writeln("  _RGB rgbR, rgbG, rgbB \t\t; call RGB macro"); // 00ff00ffh
    writeln("  mov tcolor, eax");
    writeln(" ");
    writeln("  invoke GetStockObject, DC_PEN");
    writeln("  mov gsObject, eax");
    writeln(" ");
    writeln("  invoke SelectObject, myhDC, gsObject");
    writeln("  invoke SetDCPenColor, myhDC, tcolor");
    writeln(";");
    writeln("  ret");
    writeln("pen_color endp");
    writeln("; =========================================================================");

}
/* ------ end func_setPenColor ------ */



void func_OldPen()
{
    writeln("; --------------------------------------------------");
    writeln("old_pen  proc ");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(" ");
    writeln("  invoke SelectObject, myhDC, glhOldPen");
    writeln("  invoke DeleteObject, glhNewPen \t\t ; Do not forget to clean up");
    writeln(";");
    writeln("  ret");
    writeln("old_pen endp");
    writeln("; =========================================================================");

}
/* ------ end func_OldPen ------ */



void func_NewPen()
{
    writeln("; --------------------------------------------------");
    writeln("new_pen  proc  nw1:DWORD, nc1:DWORD, nc2:DWORD, nc3:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  hPen:HPEN");
    writeln("  LOCAL  tcolor:DWORD");
    writeln("  LOCAL  rgbR:BYTE");
    writeln("  LOCAL  rgbG:BYTE");
    writeln("  LOCAL  rgbB:BYTE");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(" ");
    writeln("  loWORD nc1 \t\t\t; convert RGB DWORDs to BYTEs");
    writeln("  mov rgbR, al");
    writeln("  loWORD nc2");
    writeln("  mov rgbG, al");
    writeln("  loWORD nc3");
    writeln("  mov rgbB, al");
    writeln("  _RGB rgbR, rgbG, rgbB \t\t; call RGB macro"); // 00ff00ffh
    writeln("  mov tcolor, eax");
    writeln(" ");
    writeln("  invoke CreatePen, PS_SOLID, nw1, tcolor");
    writeln("  mov hPen, eax");
    writeln("  mov glhNewPen, eax");
    writeln(" ");
    writeln("  invoke SelectObject, myhDC, hPen");
    writeln("  mov glhOldPen, eax \t\t ;global new pen");
    writeln(";");
    writeln("  ret");
    writeln("new_pen endp");
    writeln("; =========================================================================");

}
/* ------ end func_NewPen ------ */



void func_TextColor()
{
    writeln("; --------------------------------------------------");
    write_str("text_color  proc  nc1:DWORD, nc2:DWORD, nc3:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  tcolor:DWORD");
    writeln("  LOCAL  rgbR:BYTE");
    writeln("  LOCAL  rgbG:BYTE");
    writeln("  LOCAL  rgbB:BYTE");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(" ");
    writeln("  loWORD nc1 \t\t\t; convert RGB DWORDs to BYTEs");
    writeln("  mov rgbR, al");
    writeln("  loWORD nc2");
    writeln("  mov rgbG, al");
    writeln("  loWORD nc3");
    writeln("  mov rgbB, al");
    writeln("  _RGB rgbR, rgbG, rgbB \t\t; call RGB macro"); // 00ff00ffh
    writeln("  mov tcolor, eax");
    writeln(" ");
    writeln("  invoke SetTextColor, myhDC, tcolor");
    writeln(";");
    writeln("  ret");
    writeln("text_color endp");
    writeln("; =========================================================================");

}
/* ------ end func_TextColor ------ */



void func_PixelSet()
{
    writeln("; --------------------------------------------------");
    writeln("pixel_set  proc  nx1:DWORD, ny1:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  tcolor:DWORD");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke GetDCPenColor, myhDC \t; uses current pen color");
    writeln("  mov tcolor, eax");
    writeln("  invoke SetPixel, myhDC, nx1, ny1, tcolor");
    writeln(";");
    writeln("  ret");
    writeln("pixel_set endp");
    writeln("; =========================================================================");

}
/* ------ end func_PixelSet ------ */



void func_DrawArc()
{
    writeln("; --------------------------------------------------");
    write_str("draw_arc  proc  nx1:DWORD, ny1:DWORD, nx2:DWORD, ");
    writeln("ny2:DWORD, nxs:DWORD, nys:DWORD, nxe:DWORD, nye:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke Arc, myhDC, nx1, ny1, nx2, ny2, nxs, nys, nxe, nye");
    writeln(";");
    writeln("  ret");
    writeln("draw_arc endp");
    writeln("; =========================================================================");

}
/* ------ end DrawArc ------ */



void func_DrawChord()
{
    writeln("; --------------------------------------------------");
    write_str("draw_chord  proc  nx1:DWORD, ny1:DWORD, nx2:DWORD, ");
    writeln("ny2:DWORD, nxs:DWORD, nys:DWORD, nxe:DWORD, nye:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke Chord, myhDC, nx1, ny1, nx2, ny2, nxs, nys, nxe, nye");
    writeln(";");
    writeln("  ret");
    writeln("draw_chord endp");
    writeln("; =========================================================================");

}
/* ------ end func_DrawChord ------ */



void func_DrawPie()
{
    writeln("; --------------------------------------------------");
    write_str("draw_pie  proc  nx1:DWORD, ny1:DWORD, nx2:DWORD, ");
    writeln("ny2:DWORD, nxs:DWORD, nys:DWORD, nxe:DWORD, nye:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke Pie, myhDC, nx1, ny1, nx2, ny2, nxs, nys, nxe, nye");
    writeln(";");
    writeln("  ret");
    writeln("draw_pie endp");
    writeln("; =========================================================================");

}
/* ------ end func_DrawPie ------ */



void func_DrawCircle()
{
    writeln("; --------------------------------------------------");
    writeln("draw_circle  proc  nc1:DWORD, nc2:DWORD, nrad:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  nx1:DWORD");
    writeln("  LOCAL  ny1:DWORD");
    writeln("  LOCAL  nx2:DWORD");
    writeln("  LOCAL  ny2:DWORD");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(" ");
    writeln("  mov eax, nc1");
    writeln("  sub eax, nrad");
    writeln("  mov nx1, eax");

    writeln("  mov eax, nc2");
    writeln("  sub eax, nrad");
    writeln("  mov ny1, eax");

    writeln("  mov eax, nc1");
    writeln("  add eax, nrad");
    writeln("  mov nx2, eax");

    writeln("  mov eax, nc2");
    writeln("  add eax, nrad");
    writeln("  mov ny2, eax");

    writeln(";");
    writeln("  invoke Ellipse, myhDC, nx1, ny1, nx2, ny2");
    writeln(";");
    writeln("  ret");
    writeln("draw_circle endp");
    writeln("; =========================================================================");

}
/* ------ end func_DrawCircle ------ */



void func_DrawEllipse()
{
    writeln("; --------------------------------------------------");
    writeln("draw_ellipse  proc  nx1:DWORD, ny1:DWORD, nx2:DWORD, ny2:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke Ellipse, myhDC, nx1, ny1, nx2, ny2");
    writeln(";");
    writeln("  ret");
    writeln("draw_ellipse endp");
    writeln("; =========================================================================");

}
/* ------ end func_DrawEllipse ------ */



void func_DrawSquare()
{
    writeln("; --------------------------------------------------");
    writeln("draw_square  proc  nx1:DWORD, ny1:DWORD, nw1:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  nx2:DWORD");
    writeln("  LOCAL  ny2:DWORD");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  mov eax, nx1");
    writeln("  add eax, nw1");
    writeln("  mov nx2, eax");
    writeln("  mov eax, ny1");
    writeln("  add eax, nw1");
    writeln("  mov ny2, eax");
    writeln("  invoke Rectangle, myhDC, nx1, ny1, nx2, ny2");
    writeln(";");
    writeln("  ret");
    writeln("draw_square endp");
    writeln("; =========================================================================");

}
/* ------ end func_DrawSquare ------ */



void func_DrawRndRect()
{
    writeln("; --------------------------------------------------");
    write_str("draw_rndrect  proc  nx1:DWORD, ny1:DWORD, nx2:DWORD");
    writeln(", ny2:DWORD, nw1:DWORD, nh1:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke RoundRect, myhDC, nx1, ny1, nx2, ny2, nw1, nh1");
    writeln(";");
    writeln("  ret");
    writeln("draw_rndrect endp");
    writeln("; =========================================================================");

}
/* ------ end func_DrawRndRect ------ */



void func_DrawRect()
{
    writeln("; --------------------------------------------------");
    writeln("draw_rect  proc  nx1:DWORD, ny1:DWORD, nx2:DWORD, ny2:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke Rectangle, myhDC, nx1, ny1, nx2, ny2");
    writeln(";");
    writeln("  ret");
    writeln("draw_rect endp");
    writeln("; =========================================================================");

}
/* ------ end func_DrawRect ------ */



void func_ResetOldFont()
{
    writeln("; --------------------------------------------------");
    writeln("reset_oldfont proc ");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(";");
    writeln("  invoke SelectObject, myhDC, glhOldFont");
    writeln("  invoke DeleteObject, glhNewFont");
    writeln(";");
    writeln("  ret");
    writeln("reset_oldfont endp");
    writeln("; =========================================================================");

}
/* ------ end func_ResetOldFont ------ */



void func_getGDIFont()
{
    writeln("; --------------------------------------------------");
    writeln("get_gdifont proc newfont:DWORD ");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhFont:HFONT");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln(";");
    writeln("  invoke GetStockObject, newfont");
    writeln("  mov myhFont, eax");
    writeln("  invoke SelectObject, myhDC, myhFont");
    writeln("  mov glhOldFont, eax");
    writeln("  mov eax, myhFont \t\t ; save new font to global");
    writeln("  mov glhNewFont, eax");
    writeln(";");
    writeln("  ret");
    writeln("get_gdifont endp");
    writeln("; =========================================================================");

}
/* ------ end func_getGDIFont ------ */



void func_PostMssge()
{
    writeln("; --------------------------------------------------");
    writeln("post_mssge  proc  szTx:DWORD, nx1:DWORD, ny1:DWORD, sln:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  hwnd:HWND");
    writeln(";");
    writeln("  mov eax, hWndMain");
    writeln("  mov hwnd, eax");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke TextOut, myhDC, nx1, ny1, szTx, sln");
    writeln(";");
    writeln("  invoke InvalidateRect, hwnd, addr glrect, FALSE");
    writeln("  invoke UpdateWindow, hwnd");
    writeln(";");
    writeln("  ret");
    writeln("post_mssge endp");
    writeln("; =========================================================================");

}
/* ------ end func_PostMssge ------ */



void func_DrawBox()
{
    char Lbl1[LLEN], Lbl2[LLEN], Lbl3[LLEN], Lbl4[LLEN];


    writeln("; --------------------------------------------------");
    write_str("draw_box  proc  nx1:DWORD, ny1:DWORD, nx2:DWORD, ");
    writeln("ny2:DWORD, nc1:DWORD, nc2:DWORD, nc3:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln("  LOCAL  Bcolor:DWORD");
    writeln("  LOCAL  orgVal:DWORD");
    writeln("  LOCAL  rgbR:BYTE");
    writeln("  LOCAL  rgbG:BYTE");
    writeln("  LOCAL  rgbB:BYTE");
    writeln(";");

    strcpy(Lbl1, get_NewLabel());
    strcpy(Lbl2, get_NewLabel());
    strcpy(Lbl3, get_NewLabel());
    strcpy(Lbl4, get_NewLabel());

    writeln("  loWORD nc1 \t\t\t; convert RGB DWORDs to BYTEs");
    writeln("  mov rgbR, al");
    writeln("  loWORD nc2");
    writeln("  mov rgbG, al");
    writeln("  loWORD nc3");
    writeln("  mov rgbB, al");
    writeln("  _RGB rgbR, rgbG, rgbB \t\t; call RGB macro"); // 00ff00ffh
    writeln("  mov Bcolor, eax");
    writeln(" ");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  mov  eax, nx1");
    writeln("  mov orgVal, eax");
    writeln("  dec nx2");
    writeln("  dec ny2");
    writeln(" ");

    PostLabel(Lbl1);

    writeln("  mov  eax, ny1  		;For/Next loop");
    writeln("  cmp  eax, ny2");
    write_str("  jg  ");
    write_str(Lbl2);
    writeln("		;exit loop");
    writeln("; --------------------------------------------------");
    writeln("  mov eax, orgVal");
    writeln("  mov nx1, eax");

    PostLabel(Lbl3);

    writeln("  mov  eax, nx1  		;For/Next loop");
    writeln("  cmp  eax, nx2");
    write_str("  jg  ");
    write_str(Lbl4);
    writeln("		;exit loop");
    writeln("  invoke SetPixel, myhDC, nx1, ny1, Bcolor");  //0x00ff0000 // x00bbggrr
    writeln("  inc  nx1  ");
    write_str("  jmp  ");
    write_str(Lbl3);
    writeln("		;Next n");

    PostLabel(Lbl4);

    writeln("  inc  ny1");
    write_str("  jmp  ");
    write_str(Lbl1);
    writeln("		;Next n");
    writeln("; --------------------------------------------------");

    PostLabel(Lbl2);

    writeln(";");
    writeln("  ret");
    writeln("draw_box endp");
    writeln("; =========================================================================");
}
/* ------ end func_DrawBox ------ */



void func_reDraw_Scrn()
{
    writeln("; --------------------------------------------------");
    writeln("redraw_Scrn  proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  ndx:BYTE");
    writeln("  LOCAL  xsize1:BYTE");
    writeln("  LOCAL  hwnd:HWND");
    writeln(";");
    writeln("  loWORD iLVAR");    /* this is the index number */
    writeln("  mov ndx, al");
    writeln(" ");
    writeln("  assume edi:PTR WinHwnd");
    writeln("  xor eax, eax");
    writeln("  mov al, ndx");
    writeln("  mov xsize1, sizeof(WinHwnd)");
    writeln("  mul xsize1");
    writeln("  mov edi, offset Winhndl");
    writeln("  add edi, eax");    /* offset Winhndl + (ndx * sizeof(WinHwnd) */

    writeln("  mov eax, [edi].hHandle");
    writeln("  mov hwnd, eax");

    writeln("  assume edi:nothing");
    writeln(";");
    writeln("  invoke InvalidateRect, hwnd, addr glrect, FALSE");
    writeln("  invoke UpdateWindow, hwnd");

    writeln("  .WHILE TRUE");
    writeln("    invoke PeekMessage, addr msg, NULL, 0, 0, PM_REMOVE");
    writeln("    .BREAK .IF(!eax)");
    writeln("      invoke TranslateMessage, addr msg");
    writeln("      invoke DispatchMessage, addr msg");
    writeln("  .ENDW");
    writeln("  mov  eax, msg.wParam");
    writeln(";");
    writeln("  ret");
    writeln("redraw_Scrn endp");
    writeln("; =========================================================================");
}
/* ------ end func_reDraw_Scrn ------ */



void func_drawLine()
{
    writeln("; --------------------------------------------------");
    writeln("draw_line  proc  nx1:DWORD, ny1:DWORD, nx2:DWORD, ny2:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  myhDC:HDC");
    writeln(";");
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");
    writeln("  mov myhDC, eax");
    writeln("  invoke MoveToEx, myhDC, nx1, ny1, NULL");
    writeln("  invoke LineTo, myhDC, nx2, ny2");
    writeln(";");
    writeln("  ret");
    writeln("draw_line endp");
    writeln("; =========================================================================");
}
/* ------ end func_drawLine ------ */



void func_winguiTable()
{
    writeln("; --------------------------------------------------");
    writeln("wingui_table  proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  xsize1:BYTE");
    writeln("  LOCAL  xflag1:BYTE");
    writeln(";");
    writeln("  .if flag_gui==0");      /* if this is the first window */
    writeln("      xor eax, eax");
    writeln("      inc flag_gui");
    writeln("      loWORD flag_gui");
    writeln("      mov xflag1, al");
    writeln("      mov xsize1, sizeof(WinHwnd)");
    writeln("      mul xsize1");
    writeln("      invoke malloc, eax");
    writeln("      mov Winhndl, eax");
    writeln("  .else");                /* prior windows have been created */
    writeln("      xor eax, eax");
    writeln("      inc flag_gui");
    writeln("      loWORD flag_gui");
    writeln("      mov xflag1, al");
    writeln("      mov xsize1, sizeof(WinHwnd)");
    writeln("      mul xsize1");
    writeln(";");
    writeln(";      invoke realloc, Winhndl, eax");
    writeln("      invoke realloc, addr Winhndl, eax");
    writeln("      mov Winhndl, eax");
    writeln("  .endif");
    writeln(";");
    writeln("  ret");
    writeln("wingui_table endp");
    writeln("; =========================================================================");
}
/*---------- end func_wingui_table ----------*/



void func_showwindow()
{
    writeln("; --------------------------------------------------");
    writeln("show_window  proc winName:DWORD, topx:DWORD, leftx:DWORD, widthx:DWORD, heightx:DWORD");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  ndx:BYTE");
    writeln("  LOCAL  xsize1:BYTE");
    writeln(";");
    writeln("  mov  eax, widthx");
    writeln("  mov  myWIDTH, eax");
    writeln("  mov eax, heightx");
    writeln("  mov  myHEIGHT, eax");
    writeln("  invoke GetSystemMetrics, SM_CXSCREEN");
    writeln("  mov  bufWIDTH, eax");
    writeln("  invoke GetSystemMetrics, SM_CYSCREEN");
    writeln("  mov  bufHEIGHT, eax");
    writeln(";");
    write_str("  invoke CreateWindowEx, NULL, addr szAppName, winName");
    write_str(", WS_OVERLAPPEDWINDOW, topx, leftx, widthx, heightx");
    writeln(", NULL, NULL, glhInstance, NULL");
    writeln("  mov  hWndMain, eax");
    writeln(";");
    writeln("  .if eax == NULL");
    writeln("      printstr ErrMssg1");
    writeln("      printstr lf");
    writeln("  .endif");
    writeln(";");
    writeln("  loWORD flag_gui \t\t ; get ax");
    writeln("  mov ndx, al \t\t ; save al (low byte) to ndx");
    writeln("  call wingui_table \t\t ; create struct");
    writeln(" ");
    writeln("  assume edi:PTR WinHwnd \t\t ; point edi to struct");
    writeln("  xor eax, eax");
    writeln("  mov al, ndx \t\t ; restore index to al");
    writeln("  mov xsize1, sizeof(WinHwnd)");
    writeln("  mul xsize1");
    writeln("  mov edi, offset Winhndl \t\t ; load struct address");
    writeln("  add edi, eax \t\t ; add offset");
    writeln("  invoke strcpy, addr [edi].lpzName, winName");
    writeln("  mov eax, hWndMain");
    writeln("  mov [edi].hHandle, eax \t\t ; save window handle");
    writeln(" ");
    writeln(";  printstr [edi].lpzName");  /* diagnostic routine */
    writeln(";  printstr lf");
    writeln(";  mov eax, winName");
    writeln(";  printstr [eax]");
    writeln(";  printstr lf");
    writeln(" ");
    writeln("  assume edi:nothing");
    writeln(";");
    writeln("  invoke ShowWindow, hWndMain, SW_SHOWDEFAULT");
    writeln("  invoke UpdateWindow, hWndMain");
    writeln(";");
    writeln("  ret");
    writeln("show_window endp");
    writeln("; =========================================================================");
}
/*---------- end func_showwindow ----------*/



void func_wndproc()
{
    writeln("; --------------------------------------------------");
    writeln("WndProc proc hWnd:DWORD, uMsg:UINT, wParam:WPARAM, lParam:LPARAM");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  stockobj:HBRUSH");
    writeln(";");
    writeln(".data");
    writeln("    szTextMsg  db  'Hello World!',0");
    writeln("    szWM_CREATE       db  'WM_CREATE!',13,10,0");
    writeln("    szWM_PAINT        db  'PAINT EVENT!',13,10,0");
    writeln("    szWM_DESTROY      db  'WM_DESTROY!', 13,10,0");
    writeln("    szWM_LBUTTONDOWN  db  'L-MOUSE DOWN AT ',0");
    writeln("    szWM_RBUTTONDOWN  db  'R-MOUSE DOWN AT ',0");
    writeln("    szWM_CHAR         db  'CHAR: ',0");
    writeln("    temp              db  ' ',0");
    writeln("    szWM_MOVE         db  'MOVE TO: ',0");
    writeln("    szWM_SIZE         db  'SIZE TO: ',0");
    writeln(".code");
    writeln(";");
    writeln("  mov eax, SavdcBuffer  ; this is here as a backup.");
    writeln("  mov HdcBuffer, eax    ; for some reason, HdcBuffer is getting over written.");
    writeln(";");
    writeln("  .IF uMsg == WM_CREATE");
    writeln("      invoke printf, addr szWM_CREATE");
    writeln("      ;");
    writeln("      mov glrect.left, 0");
    writeln("      mov glrect.top, 0");
    writeln("      mov eax, bufWIDTH");
    writeln("      mov glrect.right, eax");
    writeln("      mov eax, bufHEIGHT");
    writeln("      mov glrect.bottom, eax");
    writeln(" ");
    writeln("      invoke GetDC, hWnd  ; get the app windows DC (or use NULL for screen DC)");
    writeln("      mov HdcWindow, eax");
    writeln("                                              ; create comp DC and BMP");
    writeln("      invoke CreateCompatibleDC, HdcWindow      ; global scope HDC");
    writeln("      mov HdcBuffer, eax");
    writeln("      mov SavdcBuffer, eax");
    writeln("      invoke CreateCompatibleBitmap, HdcWindow, bufWIDTH, bufHEIGHT  ; global scope BMP");
    writeln("      mov DoubleBuffer, eax");
    writeln("                            ; select in BMP, catching 1x1 monochrome default BMP");
    writeln("      invoke SelectObject, HdcBuffer, DoubleBuffer   ; global scope BMP");
    writeln("      mov OldBuffer, eax");
    writeln("      invoke GetStockObject, WHITE_BRUSH            ; clear screen");
    writeln("      invoke FillRect, HdcBuffer, addr glrect, eax");
    writeln("      invoke ReleaseDC, hWnd, HdcWindow            ; clean up GDI");
    writeln("      ;");
    writeln("  .ELSEIF uMsg==WM_PAINT");
    writeln("          invoke printf,  addr szWM_PAINT");
    writeln("      invoke BeginPaint, hWnd, addr glps");
    writeln("                                 ; can use the HDC in the PAINTSTRUCT or ");
    writeln("                                 ; use the returned HDC from BeginPaint()");
    writeln("      invoke BitBlt, glps.hdc, 0, 0, myWIDTH, myHEIGHT, HdcBuffer, 0, 0, SRCCOPY");
    writeln("      invoke EndPaint, hWnd, addr glps");
    writeln("      ;");
    writeln("      ;                          ; left clicking on the client area");
    writeln("  .ELSEIF uMsg==WM_LBUTTONDOWN   ; of the window (white part)");
    writeln("      xor eax, eax");
    writeln("      loWORD lParam");
    writeln("      mov Xcoord, eax");
    writeln("      hiWORD lParam");
    writeln("      mov Ycoord, eax");
    writeln("          invoke printf, addr szWM_LBUTTONDOWN");
    writeln("          printstr tab");
    writeln("          FINIT 			; initialize x87");
    writeln("          FILD  Xcoord			; load integer");
    writeln("          FSTP  x87buff			; store in print buffer");
    writeln("          invoke FloatToStr2, x87buff, addr FltString");
    writeln("          printstr FltString");
    writeln("          printstr tab");
    writeln("          FILD  Ycoord			; load integer");
    writeln("          FSTP  x87buff			; store in print buffer");
    writeln("          invoke FloatToStr2, x87buff, addr FltString");
    writeln("          printstr FltString");
    writeln("          printstr lf");
    writeln("    ;                            ; right clicking on the client area");
    writeln("  .ELSEIF uMsg==WM_RBUTTONDOWN   ; of the window (white part)");
    writeln("      xor eax, eax");
    writeln("      loWORD lParam");
    writeln("      mov Xcoord, eax");
    writeln("      hiWORD lParam");
    writeln("      mov Ycoord, eax");
    writeln("          invoke printf, addr szWM_RBUTTONDOWN");
    writeln("          printstr tab");
    writeln("          FINIT 			; initialize x87");
    writeln("          FILD  Xcoord			; load integer");
    writeln("          FSTP  x87buff			; store in print buffer");
    writeln("          invoke FloatToStr2, x87buff, addr FltString");
    writeln("          printstr FltString");
    writeln("          printstr tab");
    writeln("          FILD  Ycoord			; load integer");
    writeln("          FSTP  x87buff			; store in print buffer");
    writeln("          invoke FloatToStr2, x87buff, addr FltString");
    writeln("          printstr FltString");
    writeln("          printstr lf");
    writeln("    ;");
    writeln("  .ELSEIF uMsg==WM_CHAR   ; character key");
    writeln("      mov eax, wParam");
    writeln("      mov temp, al");
    writeln("          invoke printf, addr szWM_CHAR");
    writeln("          invoke printf, addr temp");
    writeln("          printstr lf");
    writeln("    ;");
    writeln("  .ELSEIF uMsg==WM_MOVE   ; moving the window");
    writeln("      xor eax, eax");
    writeln("      loWORD lParam");
    writeln("      mov Xcoord, eax");
    writeln("      hiWORD lParam");
    writeln("      mov Ycoord, eax");
    writeln("          invoke printf, addr szWM_MOVE");
    writeln("          printstr tab");
    writeln("          FINIT 			; initialize x87");
    writeln("          FILD  Xcoord			; load integer");
    writeln("          FSTP  x87buff			; store in print buffer");
    writeln("          invoke FloatToStr2, x87buff, addr FltString");
    writeln("          printstr FltString");
    writeln("          printstr tab");
    writeln("          FILD  Ycoord			; load integer");
    writeln("          FSTP  x87buff			; store in print buffer");
    writeln("          invoke FloatToStr2, x87buff, addr FltString");
    writeln("          printstr FltString");
    writeln("          printstr lf");
    writeln("    ;");
    writeln("  .ELSEIF uMsg==WM_SIZE");
    writeln("    xor eax, eax");
    writeln("    loWORD lParam");
    writeln("    mov myWIDTH, eax");
    writeln("    hiWORD lParam");
    writeln("    mov myHEIGHT, eax");
    writeln("          invoke printf, addr szWM_SIZE");
    writeln("          printstr tab");
    writeln("          FINIT 			; initialize x87");
    writeln("          FILD  myWIDTH			; load integer");
    writeln("          FSTP  x87buff			; store in print buffer");
    writeln("          invoke FloatToStr2, x87buff, addr FltString");
    writeln("          printstr FltString");
    writeln("          printstr tab");
    writeln("          FILD  myHEIGHT			; load integer");
    writeln("          FSTP  x87buff			; store in print buffer");
    writeln("          invoke FloatToStr2, x87buff, addr FltString");
    writeln("          printstr FltString");
    writeln("          printstr lf");
    writeln("    ;");
    writeln("  .ELSEIF uMsg==WM_DESTROY");
    writeln("    invoke printf, addr szWM_DESTROY");
    writeln("    invoke SelectObject, HdcBuffer, OldBuffer");
    writeln("    invoke DeleteDC, HdcBuffer");
    writeln("    invoke DeleteObject, DoubleBuffer");
    writeln("    dec flag_gui");
    writeln("    ;");
    writeln("    .IF flag_gui == 0");
    writeln("        invoke PostQuitMessage, 0");
    writeln("    .ENDIF");
    writeln("    ;");
    writeln("  .ELSE");
    writeln("      invoke DefWindowProc, hWnd, uMsg, wParam, lParam");
    writeln("      ret");
    writeln("  .ENDIF");
    writeln("  mov  eax, 0");
    writeln(";");
    writeln("  ret");
    writeln("WndProc endp");
    writeln("; =========================================================================");
}
/*---------- end func_wndproc ----------*/



void func_newwindow()
{
    writeln("; --------------------------------------------------");
    writeln("new_window  proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL  hConWnd:HWND");
    writeln("  LOCAL  hwnd:HWND ");
    writeln("  LOCAL  hInstance:HINSTANCE");
    writeln("  LOCAL  wndClass:WNDCLASS");
    writeln(";");
    writeln("  call GetConsoleWndHandle");
    writeln("  mov hConWnd, eax");
    writeln("  mov hConsole, eax");
    writeln("  invoke GetWindowLong, hConWnd, GWL_HINSTANCE");
    writeln("  mov hInstance, eax");
    writeln("  mov glhInstance, eax \t\t\t; make hInstance global");
    writeln("; --------------------------------------------------");

    writeln("  invoke memset, addr wndClass, 0, SIZEOF WNDCLASS");
    writeln("  mov  wndClass.style, CS_HREDRAW or CS_VREDRAW or CS_OWNDC");
    writeln("  mov  wndClass.lpfnWndProc, OFFSET WndProc");
    writeln("  push hInstance");
    writeln("  pop  wndClass.hInstance");
    writeln("  invoke LoadCursor, hInstance, IDC_ARROW");
    writeln("  mov  wndClass.hCursor, eax");
    writeln("  invoke LoadIcon, hInstance, IDI_APPLICATION");
    writeln("  mov  wndClass.hIcon, eax");
    writeln("  invoke GetStockObject, WHITE_BRUSH");
    writeln("  mov  wndClass.hbrBackground, eax");
    writeln("  mov  wndClass.lpszClassName, offset szAppName");
    writeln(";");
    writeln("  invoke RegisterClass, addr wndClass");
    writeln("  .if eax == NULL");
    writeln("      printstr ErrMssg");
    writeln("      printstr lf");
    writeln("  .endif");
    writeln(";");
    writeln("   ret");
    writeln("new_window endp");
    writeln("; =========================================================================");
}
/*---------- end func_newwindow ----------*/






