/* bxbasm : Scangui.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */


/* ----- function prototypes ----- */
#include "prototyp.h"





void ScanWindow()
{   char ch, varname[VAR_NAME];
    int pi, type, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    e_pos = pi;

    if(ch == '\"')                     /* found a quoted string */
    {
        strcpy(varname, "szAppName");
        MakeNewVarA(varname);          /* get new varname */
    }
    else if(isalpha(ch))
    {
        strcpy(varname, get_varname());     /* get varname */
        s_pos = pi;
        pi = e_pos;
        type = get_ObjectType(varname);

        if(type == -1)                 /* an undeclared variable */
        {
            type = get_vtype(pi);      /* ch == "$%@&!#" */
        }

        if(type == 0)                  /* string variables */
        {
            Fix_String_A(varname);
        }
    }
}
/*---------- end ScanWindow ----------*/



void ScanShow()
{   char ch, varname[VAR_NAME];
    int pi, len, ndx;
    int xx=line_ndx, ab_code=56;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    e_pos = pi;

    if(ch == '\"')                     /* "myWin","myWindow1" */
    {
        get_quotedStr();               /* fetch a quoted string */
        strcpy(varname, s_holder);
        ndx = 0;                       /* struct index 0 */
                                       /* szAppName = 'MyWin' */
        if(strcmp(varname, WinHwnd[ndx].appName) != 0)
        {
            a_bort(ab_code, xx);       /* win ID does not match */
        }
        else                           /* trim p_string here */
        {
            Trim_PString();
            MakeNewVarB();
            pi = e_pos;
            len = strlen(p_string);
        }
    }

    postScan(pi, len);

}
/*---------- end ScanShow ----------*/



void ScanGen1()         /* generic scanner for gui applications */
{   char ch, varname[VAR_NAME];
    int pi, len, ndx;
    int xx=line_ndx, ab_code=54;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    e_pos = pi;
    s_pos = pi;

    if(ch == '\"')                /* "myWin","myWindow1" */
    {
        get_quotedStr();          /* fetch a quoted string */
        strcpy(varname, s_holder);
        ndx = 0;                  /* struct index 0 */
                                            /* winName = 'MyWindow1' */
        while((strcmp(varname, WinHwnd[ndx].winName) != 0) && (ndx < flag_gui))
        {
            ndx++;
        }

        if(ndx == flag_gui)
        {
            printf("\n\"%s\"", varname);
            a_bort(ab_code, xx);  /* win ID does not match */
        }
        else                      /* trim p_string here */
        {
            e_pos = s_pos;
            Trim_PString2();
            pi = e_pos;
            len = strlen(p_string);
        }
    }

    postScan(pi, len);

// printf("%spi=%d, len=%d, ch=%c\n\n", p_string, pi, len, ch);
// exit(0);

}
/*---------- end ScanGen1 ----------*/



void ScanGen2()
{   char ch, varname[VAR_NAME], value[5];
    int pi, len, ndx;
    int xx=line_ndx, ab_code=54;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    e_pos = pi;
    s_pos = pi;

    if(ch == '\"')                /* "myWin","myWindow1" */
    {
        get_quotedStr();          /* fetch a quoted string */
        strcpy(varname, s_holder);
        ndx = 0;                  /* struct index 0 */
                                            /* winName = 'MyWindow1' */
        while((strcmp(varname, WinHwnd[ndx].winName) != 0) && (ndx < flag_gui))
        {
            ndx++;
        }

        if(ndx == flag_gui)
        {
            printf("\n\"%s\"", varname);
            a_bort(ab_code, xx);  /* win ID does not match */
        }
        else                      /* trim p_string here */
        {
            e_pos = s_pos;
            Trim_PString2();
            pi = e_pos;
            len = strlen(p_string);
        }

        GetNewVar();              /* get textout string */

        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);

        if(strchr(":; ,)(", ch) != 0)  /* jump over punctuation */
        {
            pi = get_rightExp(pi);     /* get to next alpha or string */
        }

        e_pos = pi;
        ch = p_string[pi];

        itoa(szLen, value, 10);        /* save textout string length */

        p_string[(len-1)] = '\0';      /* chop trailing newline */
        strcat(p_string, ", ");
        strcat(p_string, value);       /* add number */
        value[0] = '\n';
        value[1] = '\0';
        strcat(p_string, value);       /* add newline */

        len = strlen(p_string);
    }

    postScan(pi, len);

// printf("%spi=%d, len=%d, ch=%c\n\n", p_string, pi, len, ch);

}
/*---------- end ScanGen2 ----------*/



void ScanGen3()         /* generic scanner for gui applications */
{   char ch, varname[VAR_NAME];
    int pi, len, ndx;
    int xx=line_ndx, ab_code=54;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    e_pos = pi;
    s_pos = pi;

    if(ch == '\"')                /* "myWin","myWindow1" */
    {
        get_quotedStr();          /* fetch a quoted string */
        strcpy(varname, s_holder);
        ndx = 0;                  /* struct index 0 */
                                            /* winName = 'MyWindow1' */
        while((strcmp(varname, WinHwnd[ndx].winName) != 0) && (ndx < flag_gui))
        {
            ndx++;
        }

        if(ndx == flag_gui)
        {
            printf("\n\"%s\"", varname);
            a_bort(ab_code, xx);  /* win ID does not match */
        }
        else                      /* trim p_string here */
        {
            e_pos = s_pos;
            Trim_PString2();
            pi = e_pos;
            len = strlen(p_string);
            ch = p_string[pi];
        }
    }

// printf("%spi=%d, len=%d, ch=%c\n\n", p_string, pi, len, ch);
// exit(0);

}
/*---------- end ScanGen3 ----------*/



void ScanGen4()         /* generic scanner for gui applications */
{   char ch;
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];

    if(ch == '\"')                /* "myWindow1" */
    {
        pi++;
        pi = get_quote(pi, len);
        pi = get_rightExp(pi);
        e_pos = pi;
        s_pos = pi;
    }

    postScan(pi, len);

}
/*---------- end ScanGen4 ----------*/



void ScanGen5()         /* generic scanner for gui applications */
{   char ch, varname[VAR_NAME];   /* skipping over one constant */
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    e_pos = pi;

    if(isalpha(ch))
    {
        strcpy(varname, get_varname());     /* get constant name */
        s_pos = pi;
        pi = e_pos;
        pi = get_rightExp(pi);
        e_pos = pi;
    }

//    ch = p_string[pi];
// printf("%s%s\npi=%d, len=%d, ch=%c\n\n", p_string, varname, pi, len, ch);
// exit(0);

    postScan(pi, len);

}
/*---------- end ScanGen5 ----------*/



void ScanGen6()         /* generic scanner for gui applications */
{   char ch, varname[VAR_NAME];   /* skipping over two constants */
    int pi, len;


    len = strlen(p_string);
    pi = e_pos;
    pi = iswhite(pi);
    ch = p_string[pi];
    e_pos = pi;

    if(isalpha(ch))
    {
        strcpy(varname, get_varname());     /* read constant name */
        s_pos = pi;
        pi = e_pos;
        pi = get_rightExp(pi);
        e_pos = pi;
        strcpy(varname, get_varname());     /* read constant name */
        s_pos = pi;
        pi = e_pos;
        pi = get_rightExp(pi);
        e_pos = pi;
    }

//    ch = p_string[pi];
// printf("%s%s\npi=%d, len=%d, ch=%c\n\n", p_string, varname, pi, len, ch);
// exit(0);

    postScan(pi, len);

}
/*---------- end ScanGen6 ----------*/



void postScan(int pi, int len)
{
    char ch, varname[VAR_NAME];
    int type;


    ch = p_string[pi];

    while((pi < len) && (ch != '\n'))
    {
        e_pos = pi;

        if(ch == '\"')            /* found a quoted string */
        {
            GetNewVar();          /* get new varname */
        }
        else if(isalpha(ch))
        {
            strcpy(varname, get_varname()); /* get varname */
            s_pos = pi;
            pi = e_pos;
            type = get_ObjectType(varname);

            if(type == -1)             /* an undeclared variable */
            {
                type = get_vtype(pi);  /* ch == "$%@&!#" */
            }

            if(type == 0)              /* string variables */
            {
                Fix_String_A(varname);
            }
            else if(type == 6)         /* string array */
            {
                Fix_StrArray(varname);
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else if((type >= 7) && (type <= 10)) /* numeric array */
            {
                Fix_VarArray(varname);
                pi = get_paren(pi, len);
                ScanArrayParam();
            }
            else                       /* numeric variables */
            {
                len = strlen(varname);
                s_pos = pi - len;

                Sav_Destin_A(type, varname);     /* save variable name */
            }
        }
        else if(isdigit(ch))           /* a string function number */
        {
            pi = get_NextOp(pi);
            ch = p_string[pi];

            if(ch == '(')              /* is it a: 2(string) */
            {
                len = scanStr_funct(len);
            }
            else                       /* or: 2+2 */
            {
                GetNewTmp();           /* get new temp varname */
            }
        }

        pi = e_pos;
        ch = p_string[pi];
        len = strlen(p_string);

        if(strchr(":; ,)(", ch) != 0)       /* jump over punctuation */
        {
            pi = get_rightExp(pi);          /* get to next alpha or string */
        }
        else if(strchr("$%!#@&", ch) != 0)  /* jump over var types */
        {
            pi = get_rightExp(pi);          /* get to next alpha or string */
        }
        else if(strchr("+-*/^", ch) != 0)   /* jump over operators */
        {
            pi = get_rightExp(pi);          /* get to next alpha or string */
        }

        e_pos = pi;
        ch = p_string[pi];
    }

// printf("%spi=%d, len=%d, ch=%c\n\n", p_string, pi, len, ch);
}
/*---------- end postScan ----------*/












