/* bxbasm : prototyp.h : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012        */



/* ----- function prototypes ----- */
/* ------------------------------- */

/*------ Bxbasm.c ------*/
    void pgm_parser(void);
    void get_token(void);
    void parser(void);
    void num_label(void);
      /* Bxbasm */


/*------ Error.c ------*/
    void a_bort(int,int);
    void dump(void);
      /* Error */


/*------ Input.c ------*/
    void line_cnt(char *argv[]);
    void load_src(void);
    void save_tmp(void);
    void tmp_byte(int);
    void loader_1(void);
    void tmp_label(int);
    void tmp_byte(int);
     int get_byte(int);
    void tmp_prog(int);
    void loader_2(void);
    void get_MOD(int);
    void token_if(int);
    void str_functn(int);
     int IsEqu(int);
    void get_strfunc(char *,int);
    void str_copy(char *,int);
    void str_funct2(int);
    void get_mathfunc(char *,int);
    void var_types(int);
    void load_srx(void);

      /* Input */



/*------ Utility.c ------*/
     int get_upper(int,int);
     int get_alpha(int,int);
     int get_digit(int,int);
     int iswhite(int);
    void clr_arrays(void);
     int iswhiter(int);
     int find_strng(char *);
     int get_paren(int,int);
     int get_NextOp(int);
     int get_Nvtype(int);
     int get_vtype(int);
     int get_rightExp(int);
     int get_alnum(int,int);
     int while_isalnum(int);
     int get_quote(int,int);
    void Build_arrays(void);
    void Kill_arrays(void);
     int get_Dvtype(int);
     int isthis_anarray(int,int);
    void get_param_name(void);
    void get_quotedStr(void);

      /* Utility */



/*------ AFile.c ------*/
    void init_fldbffrs(void);
    void parse_open(void);
    void Do_fclose(void);
    void write_io(void);
    void input_io(void);
    void Do_field(void);
    void Do_lset(void);
    void Do_put(void);
    void Do_get(void);
    void Do_rset(void);
    void lineinput_io(void);
    void print_file(int);
    void parse_shell(void);
    void parse_chd(void);
    void parse_mkd(void);
    void parse_rmd(void);
    void parse_kill(void);
    void parse_name(void);
    void parse_chdrive(void);
    void Do_lprint(void);

      /* AFile */




/*------ AString.c ------*/
    void parse_str(char *);
    void str_express(char *);
    void cat_string(int);
    void copy_string(int);
    void asn_function(int);
    void cat_function(int);
    void string_functions(int,int);
    void chrstr(int);
    void leftstr(int);
    void rightstr(int);
    void midstr(int);
    void spacestr(int);
    void strsval(int);
    void stringstr(int);
    void inkeystr(void);
    void inputstr(int);
    void mkistr(int);
    void mkdstr(int);
    void datestr(void);
    void timestr(void);
    void asn_strarry(void);
    void cat_strarry(void);
    void asn_string(char *);
    void asnStr_express(char *);
    void ucasestr(void);
    void lcasestr(void);
    void get_INSTR(void);

      /* AString */



/*------ AIf.c ------*/
    void Do_if(void);
    void Do_elseif(void);
    void Do_else(void);
    void Do_endif(void);
     int check_or(void);
    void or_true(int);
    void check_lsif(void);
    void check_else(void);
    void boolexpress(void);
     int Nboolterm(int);
     int Nrelation(void);
     int get_op(void);
     int IsAndOrOp(int);
     int get_Exptype(void);
     int look_Or(void);
    char *jump_if(int,char);
     int Sboolterm(int);
     int Srelation(void);
     int if_eof(void);
     int is_eof(void);

    void Do_Switch(void);
    void Do_SwitchCase(void);
    void Do_SwitchDefault(void);
    void Do_EndSwitch(void);

      /* AIf */



/*------ AInput.c ------*/
    void Header(void);
    void open_destin(void);
    void Prolog(void);
    void ScanVars(void);
    void Epilog(void);
    void assemble(void);

    void SystemConst(void);
    void load_tmpdata(void);

      /* AInput */



/*------ Scandim.c ------*/
    void ScanDim(void);
    void dim_var(void);
    void parse_dim(void);
    void ScanDimString(char *);
    void ScanDimNumeric(char *, int);
     int scanStr_funct(int);
    void Sav_Destin(int,char *);
    void dim_array(void);
    void Fix_String(char *);
    void Fix_StrArray3(char *,int);
    void Fix_VarArray3(char *,int,int);
    void Fix_StrArray(char *);
    void Fix_VarArray(char *);

    void dim_local_var(void);
    void parse_local_dim(void);
    void Scan_LocalDim_String(char *);
    void Fix_Local_String(char *);
    void Sav_LocalString(char *);
    void Scan_LocalDim_Numeric(char *, int);
    void Sav_Local_Destin(int, char *);

      /* Scandim */



/*------ Scanlet.c ------*/
    void ScanLet(void);
    void ScanString(char *);
    void ScanStrArray(char *);
    void ScanNumArray(char *,int);
    void ScanNumeric(char *);
    void Fix_String_A(char *);
    void ScanArrayParam(void);
    void Scan_Array(char *,int);
    void ScanMathFunc(int);
    void Sav_Destin_A(int, char *);

      /* Scanlet */



/*------ Scanfor.c ------*/
    void ScanFor(void);
    void LexFor(char *);
    void LexTo(void);
    void LexStep(int);
    void defaultStep(int);

      /* Scanfor */



/*------ Scanprint.c ------*/
    void ScanPrint(void);
    void ScanFPrint(void);
    void ScanLPrint(void);

      /* Scanprint */



/*------ Scanmisc.c ------*/
    void ScanParam(void);
    void ScanJump(void);
    void ScanIf(void);
    void ScanFInput(void);
    void ScanMsgBox(void);
    void ScanDeclare(void);
    void DeclareSub(void);
    void ScanSub(void);

      /* Scanmisc */



/*------ Scanfile.c ------*/
    void ScanOpen(void);
    void ScanWrite(void);
    void ScanField(void);
    void ScanPut(void);
    void ScanRename(void);
    void ScanFiles(void);
    void ScanShell(void);
    void ScanErase(void);

      /* Scanfile */



/*------ Scangui.c ------*/
    void ScanWindow(void);
    void ScanShow(void);
    void ScanGen1(void);
    void ScanGen2(void);
    void postScan(int,int);
    void ScanGen3(void);
    void ScanGen4(void);
    void ScanGen5(void);
    void ScanGen6(void);

      /* Scangui */



/*------ ANInput.c ------*/
    char *NewFVarname(void);
    void AddNewVar(void);
    void AddNewVar_A(void);

      /* ANInput */



/*------ ARdp.c ------*/
    void Assignment(void);
    void a_Expression(void);
    void a_Term(void);
    void a_Factor(void);
    void Ident(void);
    void Add(void);
    void Subtract(void);
    void Multiply(void);
    void Divide(void);
    void Power(void);
    void Modulo(void);
    void Match(char);
    void _GetChar(void);
     int IsAddop(char);
     int IsMultop(char);
     int Is_White(char);
    void SkipWhite(void);
    void math_functn(void);
    void get_ABS(void);
    void get_ASC(void);
    void get_ATN(void);
    void get_COS(void);
    void get_SIN(void);
    void get_TAN(void);
    void get_SQRT(void);
    void get_INT(void);
    void get_LEN(void);
    void get_CVD(void);
    void get_CVI(void);
    void get_ATAN2(void);
    void get_COSH(void);
    void get_SINH(void);
    void get_TANH(void);
    void get_ACOS(void);
    void get_ASIN(void);
    void get_CEIL(void);
    void get_FLOOR(void);
    void get_HYPOT(void);
    void get_LOG(void);
    void get_LOG10(void);
    void get_RAND(void);
    void seed_rand(void);
    void get_CLOCK(void);
    void get_VAL(void);
    void get_LOC(void);
    void get_LOF(void);
    void get_EOF(void);
    void asn_numarry(char *,int);
    void get_SECONDS(void);
    void get_DRIVE(void);
    void get_EXP(void);
    void get_FABS(void);
    void get_FMOD(void);
    void get_LDEXP(void);
    void get_MODF(void);
    void get_POW(void);
    void get_POW10(void);
    void get_FREXP(void);
    void get_LABS(void);
    void get_HiRezTimer(void);
    void get_SGN(void);
    void get_MODii(void);
    void get_CINT(void);
    void get_CDBL(void);
    void get_CSNG(void);
    void get_CLNG(void);

      /* ARdp */


/*------ ALoops.c ------*/
    void Do_for(void);
    void Do_next(void);
    void Do_while(void);
    void Do_wend(void);
    void wboolexpress(void);
     int WNrelation(void);
     int WIsAndOrOp(int);
     int isUnary_Exp(void);
     int do_UnaryExp(int);
     int x_WNrelation(void);
     int Unary_NOT(void);
     int wcheck_or(void);
    void wor_true(int);
     int Unary_TRUE(void);
    void Do_loop(void);
    void Do_endloop(void);
    void Do_break(void);
    void Do_do(void);
    void Do_dowhile(void);

      /* ALoops */




/*------ AFunct.c ------*/
    void Do_initialize(void);
    void Do_cls(void);
    void Do_end(void);
    void Do_beep(void);
    void Do_print(void);
    void prn_expression(void);
    void Do_goto(void);
    void Do_label(void);
    void Do_gosub(void);
    void Do_return(void);
    void Do_locate(void);
    void Do_functions(void);
    void copystrng_bffr(void);
    void func_chrstr(void);
    void func_leftstr(void);
    void func_rightstr(void);
    void func_midstr(void);
    void func_spacestr(void);
    void func_strsIval(void);
    void func_strsFval(void);
    void func_stringstr(void);
    void func_inkeystr(void);
    void func_inputstr(void);
    void func_mkistr(void);
    void func_mkdstr(void);
    void func_mkqstr(void);
    void func_wherexy(void);
    void func_resetcursor(void);
    void func_getsysdate(void);
    void func_getsystime(void);
    void func_datestr(void);
    void func_timestr(void);
    void prn_function(int);
    void func_closeallfiles(void);
    void func_closeafile(void);
    void func_getfilehandle(void);
    void func_clearstrng_bffr(void);
    void func_setupiobuffer(void);
    void func_lsetstr(void);
    void func_rsetstr(void);
    void func_clear_allvars(void);
    void func_clearstrvar(void);
    void func_clearintvar(void);
    void func_clearfltvar(void);
    void func_clearLngstrng_bffr(void);
    void func_movstrng_bffr(void);
    void func_readintstr(void);
    void func_readfltstr(void);
    void func_readQintstr(void);
    void func_getfilelength(void);
    void func_setcolortext(void);
    void func_dimstrarray(void);
    void func_getArryOffst(void);
    void prn_strarry(char *,int);
    void func_dblArryElement(void);
    void func_quadArryElement(void);
    void func_freeArray(void);
    void func_redimarray(void);
    void func_hrtimer(void);

      /* AFunct */



/*------ AFunctW.c ------*/
    void Do_WinFunctions(void);

    void func_newwindow(void);
    void func_wndproc(void);
    void func_showwindow(void);
    void func_winguiTable(void);
    void func_drawLine(void);
    void func_reDraw_Scrn(void);
    void func_DrawBox(void);
    void func_PostMssge(void);
    void func_getGDIFont(void);
    void func_ResetOldFont(void);
    void func_DrawRect(void);
    void func_DrawRndRect(void);
    void func_DrawSquare(void);
    void func_DrawEllipse(void);
    void func_DrawCircle(void);
    void func_DrawPie(void);
    void func_DrawChord(void);
    void func_DrawArc(void);
    void func_PixelSet(void);
    void func_TextColor(void);
    void func_NewPen(void);
    void func_OldPen(void);
    void func_setPenColor(void);
    void func_setBGColor(void);
    void func_ClearWindow(void);
    void func_setBKMode(void);
    void func_ReSizeWin(void);
    void func_get_Point(void);
    void func_gdiCreatePen(void);
    void func_gdiLogBrush(void);
    void func_gdiCreateBrushInd(void);
    void func_OldBrush(void);


      /* AFunctW */



/*------ AVars.c ------*/
    void Do_let(void);
    void asn_integer(int,char *);
    void asn_float(int,char *);
    void get_input(void);
    void get_lninput(void);
    void clr_vars(void);
    void Do_color(void);

    void Do_dim(void);
    void Do_dimVar(void);
    void Do_dimArray(void);

    void parse_strArry(char *);
    void get_offset(char *,int,int);
    void parse_intArry(char *,int);
    void parse_fltArry(char *,int);
    void Do_erase(void);
    void Do_redimArray(void);

      /* AVars */



/*------ AUtils.c ------*/
    void PostLabel(char *);
    char *get_varname(void);
    char *get_NewLabel(void);
    void writeln(char *);
    void write_str(char *);
    void s_writeln(char *);
    void s_write_str(char *);
    void i_writeln(char *);
    void i_write_str(char *);
    void f_writeln(char *);
    void f_write_str(char *);
    void x_write_str(char *);
    void x_writeln(char *);
  double get_avalue(void);
    void Do_asm(void);
     int check_arrayName(char *);
    void InitArrays(void);
     int get_paramsCount(int,int);
     int verify_arrayName(char *);
     int check_VarName(char *);
    void InitVars(void);
     int verify_VarName(char *);
    void InitObj(void);
     int get_ObjectType(char *);
     int get_ObjectParm(char *);
    void GetNewVar(void);
    void Sav_String(char *);
    void Sav_String_A(char *);
    void StorVar(char *);
    void Sav_ObjName(char *,int,int);
    char *NewVarname(void);
    void Fix_VarName(char *,int);
    void Fix_StrArray2(char *);
    void Fix_VarArray2(char *,int);
     int relocate(int,int);
    void GetNewTmp(void);
    void StorNVar(char *);
    void save_ArrayParam(char *, int);
    void MakeNewVarA(char *);
    void MakeNewVarB(void);
    void Trim_PString(void);
    void Trim_PString2(void);

      /* AUtils */



/*------ ADInput.c ------*/

    void Scan_Var(char *);
    void Scan_Obj(char *);

      /* ADInput */



/*------ Output.c ------*/
    void Do_Sleep(void);
    void do_pause(void);
    void do_messagebox(void);

      /* Output */



/*------ ASubs.c ------*/
    void Do_Sub(void);
    void Do_EndSub(void);
    void Switch_IOHandle(void);
    void Flip_IOHandle(void);
    void Do_sub_functions(void);
    void do_callsub(void);
    void PreScan_DimLocal(void);

      /* ASubs */



/*------ AWingui.c ------*/
    void fetch_nparam(void);
    void fetch_sparam(void);
    void wingui_table(void);
     int get_WinNdx(char *);
    void new_window(void);
    void guiShow(void);
    void DrawLine(void);
    void reDraw_Scrn(void);
    void DrawBox(void);
    void PostMssge(void);
    void getGDIFont(void);
    void ResetOldFont(void);
    void DrawRect(void);
    void DrawRndRect(void);
    void DrawSquare(void);
    void DrawEllipse(void);
    void DrawCircle(void);
    void DrawPie(void);
    void DrawChord(void);
    void DrawArc(void);
    void PixelSet(void);
    void TextColor(void);
    void NewPen(void);
    void OldPen(void);
    void setPenColor(void);
    void setBGColor(void);
    void ClearWindow(void);
    void setBKMode(void);
    void ReSizeWin(void);


      /* AWingui */


/*------ AWingdi.c ------*/
    void get_TextColor(void);
    void get_BKColor(void);
    void get_BKMode(void);
    void get_Point(void);
    void gdi_Create_Pen(void);
    void gdi_LogBrush(void);
    void gdi_Create_BrushInd(void);
    void OldBrush(void);


      /* AWingdi */



/*------ AConsole.c ------*/
    void func_GetConslWndHandl(void);


      /* AConsole */










