/* Bxbasm : AConsole.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012        */


/* ----- includes ----- */
#include "prototyp.h"


/***********************
   variable types:
    int    = no symbol,
    long   = %,
    float  = !,
    double = #,
    string = $
/* ---------------
   array types:
    long   = %,
    float  = !,
    double = #,
    string = $
***********************/




void func_GetConslWndHandl()
{
    writeln("; --------------------------------------------------");
    writeln("GetConsoleWndHandle proc");
    writeln("; --------------------------------------------------");
    writeln("  LOCAL   hConWnd:HWND");
    writeln("  LOCAL   os:OSVERSIONINFO");
    writeln("  LOCAL   szTempTitle[64]:BYTE");
    writeln("  LOCAL   szClassName[128]:BYTE");
    writeln("  LOCAL   szOriginalTitle[1024]:BYTE");
    writeln("  LOCAL   TkCnt:DWORD");
    writeln("  LOCAL   CurProcID:DWORD");
    writeln(";");
    writeln("  mov os.dwOSVersionInfoSize, sizeof OSVERSIONINFO");
    writeln("  invoke GetVersionEx, addr os");
    writeln("  invoke GetConsoleTitle, addr szOriginalTitle, sizeof szOriginalTitle");
    writeln("  call GetCurrentProcessId");
    writeln("  mov  CurProcID, eax");
    writeln("  call GetTickCount");
    writeln("  mov TkCnt, eax");

//;    invoke sprintf, szTempTitle, szPrmStr, TkCnt, CurProcID

    writeln("  push  CurProcID");
    writeln("  push  TkCnt");
    writeln("  lea  eax, szPrmStr");
    writeln("  push eax");
    writeln("  lea  eax, szTempTitle");
    writeln("  push eax");
    writeln("  call  sprintf");
    writeln("  invoke SetConsoleTitle, addr szTempTitle");
    writeln("  invoke Sleep, 40");
    writeln("  invoke FindWindow, NULL, addr szTempTitle");
    writeln("  mov  hConWnd, eax");
    writeln("  invoke SetConsoleTitle, addr szOriginalTitle");
    writeln("  mov  eax, hConWnd");
    writeln("  ret");
    writeln("GetConsoleWndHandle endp");
    writeln("; =========================================================================");
}
/* ------ end GetConslWndHandl ------ */












