/* Bxbasm : AWingdi.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012       */



/* ----- includes ----- */
#include "prototyp.h"

/***********************
   variable types:
    int    = no symbol,
    long   = %,
    float  = !,
    double = #,
    string = $
/* ---------------
   array types:
    long   = %,
    float  = !,
    double = #,
    string = $
***********************/








void OldBrush()              /* restore old brush */
{
    writeln("  call gdi_oldbrush \t\t\t; restore old brush");

    resetoldbrush = 1;

}
/* ------ end OldBrush ------ */



void gdi_Create_BrushInd()        /* wrapper for CreateBrushIndirect() */
{
    writeln("  call gdi_createbrushind");

    createbrushind = 1;

}
/* ------ end gdi_Create_BrushInd ------ */



void gdi_LogBrush()          /* used for CreateBrushIndirect() */
{
    char brStyle[VAR_NAME], brPattern[VAR_NAME];


    fetch_sparam();
    strcpy(brStyle, s_holder);    /* brush style value */

    fetch_sparam();
    strcpy(brPattern, s_holder);  /* brush pattern value */

    fetch_sparam();
    strcpy(C1, s_holder);         /* R color value */

    fetch_sparam();
    strcpy(C2, s_holder);         /* G color value */

    fetch_sparam();
    strcpy(C3, s_holder);         /* B color value */

    write_str("  invoke gdi_logbrush, ");
    write_str(brStyle);
    write_str(", ");
    write_str(brPattern);
    write_str(", ");
    write_str(C1);
    write_str(", ");
    write_str(C2);
    write_str(", ");
    writeln(C3);

    gdilogbrush = 1;

}
/*---------- end gdi_LogBrush ----------*/



void gdi_Create_Pen()             /* wrapper for CreatePen() */
{
    char PenStyle[VAR_NAME];


    fetch_sparam();
    strcpy(PenStyle, s_holder);   /* pen style value */

    fetch_sparam();
    strcpy(width, s_holder);      /* pen width value */

    fetch_sparam();
    strcpy(C1, s_holder);         /* R color value */

    fetch_sparam();
    strcpy(C2, s_holder);         /* G color value */

    fetch_sparam();
    strcpy(C3, s_holder);         /* B color value */

    write_str("  invoke gdi_createpen, ");
    write_str(PenStyle);
    write_str(", ");
    write_str(width);
    write_str(", ");
    write_str(C1);
    write_str(", ");
    write_str(C2);
    write_str(", ");
    write_str(C3);
    writeln(" \t; create new pen");

    gdicreatepen = 1;

}
/* ------ end gdi_Create_Pen ------ */



void get_Point()             /* determine the current pixel color */
{
    char value1[5], value2[5];


    fetch_nparam();               /* left edge */
    strcpy(value1, s_holder);     /* X value */

    fetch_nparam();               /* top edge */
    strcpy(value2, s_holder);     /* Y value */

    write_str("  mov eax, ");
    writeln(value1);
    writeln("  mov iLVAR, eax");

    write_str("  mov eax, ");
    writeln(value2);
    writeln("  mov iRVAR, eax");

    writeln("  call get_point");
    writeln("  mov   iLVAR, eax");
    writeln("  FILD  iLVAR");

    getpoint = 1;

}
/* ------ end get_Point ------ */



void get_BKMode()       /* determine the current background mode */
{
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");

    writeln("  invoke GetBkMode, HdcBuffer \t; get current background mode");
    writeln("  mov   iLVAR, eax");
    writeln("  FILD  iLVAR");

}
/* ------ end get_BKMode ------ */



void get_BKColor()           /* determine the current background color */
{
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");

    writeln("  invoke GetBkColor, HdcBuffer \t; get the current background color");
    writeln("  mov   iLVAR, eax \t; integer value is in eax");
    writeln("  FILD  iLVAR");

}
/* ------ end get_BKColor ------ */



void get_TextColor()         /* determine the current text color */
{
    writeln("  mov eax, SavdcBuffer");
    writeln("  mov HdcBuffer, eax");

    writeln("  invoke GetTextColor, HdcBuffer \t; get the current text color");
    writeln("  mov   iLVAR, eax \t; integer value is in eax");
    writeln("  FILD  iLVAR");

}
/* ------ end get_TextColor ------ */










