/* BXBLIB.C */
/*
/*  *************BxbAsm Compiler*************
/*  Copyright: sarbayo (c) 2004-2012
/* ========================================================================= */


#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#include "bxblib.h"






void _stdcall StrToFloat(char *NumStr, double *result)
{

    *result = atof(NumStr);

}
/* ------ end locate ------ */



void _stdcall locate(int cx, int cy)
{
    COORD coordScreen;
    HANDLE hConsole;


    coordScreen.X = cx;
    coordScreen.Y = cy;
                             /* Get this console handle */
    hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

                             /* Put the cursor at its coordinates */
    SetConsoleCursorPosition(hConsole, coordScreen);

}
/* ------ end locate ------ */



void _stdcall ClearScreen()
{
    COORD coordScreen = { 0, 0 };    // home for the cursor
    DWORD cCharsWritten;
    CONSOLE_SCREEN_BUFFER_INFO csbi;
    DWORD dwConSize;

    HANDLE hConsole;


    hConsole = GetStdHandle(STD_OUTPUT_HANDLE);

    // Get the number of character cells in the current buffer.

    if(!GetConsoleScreenBufferInfo(hConsole, &csbi))
    {
        printf("abort at: 1\n");
        return;
    }

    dwConSize = csbi.dwSize.X * csbi.dwSize.Y;

    // Fill the entire screen with blanks.

    if(!FillConsoleOutputCharacter(hConsole, (TCHAR) ' ', dwConSize, coordScreen, &cCharsWritten))
    {
        printf("abort at: 2\n");
        return;
    }

    // Get the current text attribute.

    if(!GetConsoleScreenBufferInfo(hConsole, &csbi))
    {
        printf("abort at: 3\n");
        return;
    }

    // Set the buffer's attributes accordingly.

    if(!FillConsoleOutputAttribute(hConsole, csbi.wAttributes, dwConSize, coordScreen, &cCharsWritten))
    {
        printf("abort at: 4\n");
        return;
    }

    // Put the cursor at its home coordinates.

    SetConsoleCursorPosition(hConsole, coordScreen);

}
/*------ end ClearScreen ------*/



void _stdcall testlib()
{
    printf("hello world!\n");
    printf("test called from .lib file\n\n");

    system("pause");

}
/*------ end testlib ------*/



void _stdcall FloatToStr2(double orgvalue, char *buffer)
{   char asciiValue[30];
    int len;


    _gcvt(orgvalue, 80, buffer);       /* convert double to ascii */

    len = strlen(buffer);
    len--;

    if(buffer[len] == '.')
    {                             /* if this is an integer, get rid */
        buffer[len] = '\0';       /* of trailing decimal point. */
    }

    if(orgvalue >= 0)
    {
        strcpy(asciiValue, " ");       /* add leading blank space */
        strcat(asciiValue, buffer);
        strcpy(buffer, asciiValue);
    }
}
/*------ end FloatToStr2 -------*/


//char * _stdcall value2strng()
//char * _stdcall value2strng(double value)

char * _stdcall value2strng(double value, char vartype)
{   static char buffer[81];
    int len, idx=0, dot=0;
    char ch, chx = vartype;
//    char ch, chx='#';
//    double value = 10;


    /* --- convert to ascii, here --- */
    sprintf(buffer, "% f", value);
    len = strlen(buffer);
    ch = buffer[idx];

    /* --- trim trailing zeros --- */
    if(chx == '#')                          /* Double: '#' */
    {
        idx = (len-1);
        ch = buffer[idx];

        while(ch == '0')
        {
            idx--;
            ch = buffer[idx];
        }
        buffer[(idx+1)] = '\0';
    }

    /* --- round up to .nn --- */
    else if(chx == '!')                     /* Single: '!' */
    {
        dot = (len-5);
        idx = (len-1);

        while(idx > dot)
        {
            if((buffer[idx] >= '5') && (buffer[(idx-1)] == '9'))
            {
                buffer[idx] = '\0';
            }
            else if(buffer[idx] >= '5')
            {
                buffer[(idx-1)]++;
                buffer[idx] = '\0';
            }
            else
            {
                buffer[idx] = '\0';
            }
            idx--;
        }
    }
    /* --- trim to dot --- */
    else                           /* Integers: '%' */
    {
        idx = (len-7);
        buffer[idx] = '\0';
    }

    return buffer;
}
/*------ end value2strng -------*/



