/* bxbasm : Error.c : Masm, JWasm  alpha version 1.06.3 */
/* Bxbasic, Bxbasm (C) Copyright sarbayo, 2004-2012      */



/* ----- includes ----- */
#include "prototyp.h"



void a_bort(int code, int x)
{
    switch(code)
    {   case 1:
            printf("Unspecified Program Name.\n");
            printf("Enter:\"bxbasm source.bas\"\n");
            printf("code(%d)\n",code);
            break;
        case 2:
            printf("Program file:\"%s\" not found.\n", t_holder);
            printf("Enter: \"bxbasm source.bas\"\n");
            printf("Program Terminated.\ncode(%d)\n", code);
            break;
        case 3:
            printf("\nSyntax error: in program line: %d.\n",(x+1));
            printf("LOCATE %s", p_string);
            printf("Use: LOCATE row, column\ncode(%d)\n", code);
            break;
        case 4:
            printf("\nSyntax error: in program line:");
            printf(" %d.\n%s",(x+1),p_string);
            printf("Unknown Command.\ncode(%d)\n", code);
            break;
        case 5:
            printf("\nVariable Type error: in program line:");
            printf(" %d.\n%sType must be: ",(x+1),p_string);
            printf("String, Integer or Float:%s\n","$%@!#");
            printf("code(%d)\n",code);
            break;
        case 6:
            printf("\nSyntax error: in program line: %d.\n",(x+1));
            printf("%s", p_string);
            printf("Useage: LET (variable=assignment):\ncode(%d)\n", code);
            break;
        case 7:
            printf("\nExpected \'variable name\' error\n");
            printf(": in line: %d.\n", (x+1));
            printf("Found digit or symbol instead.\n");
            printf("%scode(%d)\n", p_string, code);
            break;
        case 8:
            printf("\nString variable error: in line: ");
            printf("%d.\n%s", (x+1), p_string);
            printf("Expected variable name or quoted string.\n");
            printf("Found digit instead.\ncode(%d)\n", code);
            break;
        case 9:
            printf("\nVariable Type error: in program line:");
            printf(" %d.\nFOR %sType must be: ",(x+1),p_string);
            printf("Integer.\ncode(%d)\n",code);
            break;
        case 10:
            printf("\nSyntax error: in program line: %d.\n",(x+1));
            printf("\tIF %s", p_string);
            printf("Useage: IF value[expression] = value[expression]");
            printf(" THEN\ncode(%d)\n", code);
            break;
        case 11:
            printf("\nLogical Operator error: in program line: ");
            printf("%d.\n\tIF %s",(x+1), p_string);
            printf("Useage: IF exp1 (operator) exp2 THEN\n");
            printf("Where: operators are: =, <, >, <>, <=, >=\n");
            printf("code(%d)\n", code);
            break;
        case 12:
            printf("\nExpected %s ",t_holder);
            printf(": in line: %d.\n", (x+1));
            printf("%scode(%d)\n", p_string, code);
            break;
        case 13:
            printf("\nExpected : String variable or Quoted string:\n");
            printf("in program line: %d.\n",(x+1));
            printf("\tIF %s", p_string);
            printf("Useage: IF \"string\" = \"string\"");
            printf(" THEN\ncode(%d)\n", code);
            break;
        case 14:
            printf("\nIF {...} THEN: error: in program line: ");
            printf("%d.\n\tIF %s",(x+1), p_string);
            printf("Useage: IF [expression] = [expression] THEN");
            printf("\ncode(%d)\n", code);
            break;
        case 15:
            printf("\nVariable Type error: in program line:");
            printf(" %d.\nLINE INPUT%s",(x+1),p_string);
            printf("Type must be: String$\ncode(%d)\n",code);
            break;
        case 16:
            printf("\nFile OPEN error: in program line:");
            printf(" %d.\nOPEN %s",(x+1),p_string);
            printf("Invalid Open MODE:\'I,O,A,R.\'\nUsage:\n");
            printf("OPEN \"I\", #1, \"filename\"\ncode(%d)\n",code);
            break;
        case 17:
            printf("\nFile OPEN error: in program line:");
            printf(" %d.\nOPEN %s",(x+1),p_string);
            printf("Invalid File Number:\'1 to 99.\'\nUsage:\n");
            printf("OPEN \"I\", #1, \"filename\"\ncode(%d)\n",code);
            break;
        case 18:
            printf("\nFile OPEN error: in program line:");
            printf(" %d.\nOPEN %s",(x+1),p_string);
            printf("Invalid FileName.\nUsage:\n");
            printf("OPEN \"I\", #1, \"filename\"\ncode(%d)\n",code);
            break;
        case 19:
            printf("\nLSET error: in program line: %d.\n",(x+1));
            printf("%sLSET must reference an open file",p_string);
            printf(" buffer.\nUsage:\nFIELD #1, 10 AS abc$\n");
            printf("LSET abc$ = data$\ncode(%d)\n",code);
            break;
        case 20:
            printf("\nDIM error: in program line: %d.\n",(x+1));
            printf("DIM %sDuplicate variable name.\nArrays ",p_string);
            printf("names must be unique from variable names.\n");
            printf("code(%d)\n",code);
            break;
        case 21:
            printf("\nArray assignment error: in program line: ");
            printf("%d.\n%sInvalid assignment ",(x+1),p_string);
            printf("to numeric array.\ncode(%d)\n",code);
            break;
        case 22:
            printf("\nERASE error: in program line: %d.\n",(x+1));
            printf("ERASE %sObject is not an ARRAY.\n",p_string);
            printf("code(%d)\n",code);
            break;
        case 23:
            printf("\nString error: in program line: %d.\n",(x+1));
            printf("%sMissing ending quote (\").\n", p_string);
            printf("Useage: \"quoted text string\".\ncode(%d)\n", code);
            break;
        case 24:
            printf("\nCLEAR error: in program line: %d.\n",(x+1));
            printf("CLEAR %sObject is an ARRAY. Cannot ",p_string);
            printf("CLEAR an ARRAY.\nUse: ERASE arrayname\n");
            printf("code(%d)\n",code);
            break;
        case 25:
            printf("\nArray assignment error: in program line: ");
            printf("%d.\nDIM %sInvalid DIMension. ",(x+1),p_string);
            printf("Object is not an array.\nUsage: DIM array");
            printf("[%s](subscript).\ncode(%d)\n","%!@#$", code);
            break;
        case 26:
            printf("\nDIM error: in program line: %d.\n",(x+1));
            printf("VAR %sDuplicate variable name.\nArrays ",p_string);
            printf("names must be unique from variable names.\n");
            printf("code(%d)\n",code);
            break;
        case 27:
            printf("\nFile Handle error: in program line: %d.\n",(x+1));
            printf("Expected file number: (1...99). Found variable");
            printf(" name instead:\n%s",p_string);
            printf("Usage: function(1)\ncode(%d)\n",code);
            break;
        case 28:
            printf("\nSyntax error: in program line: %d.\n",(line_ndx+1));
            printf("%s", p_string);
            printf("Usage DIM [variable] = [assignment]:\ncode(%d)\n", code);
            break;
        case 29:
            printf("\nDIM error: in program line: %d.\n",(x+1));
            printf("DIM %sDuplicate variable name.\nAll ",p_string);
            printf("variables must have unique variable names.\n");
            printf("code(%d)\n",code);
            break;
        case 30:
            printf("\nVariable not found: in line: %d.\n", (x+1));
            printf("%scode(%d)\n", p_string, code);
            break;
        case 31:
            printf("\nDIM error: in program line: %d.\n",(line_ndx+1));
            printf("%s", p_string);
            printf("\nOnly a literal character string or number value may\n");
            printf("be used as the rightside value in a DIM statement.\n\n");
            printf("Usage DIM [variable] = [literal]:\ncode(%d)\n", code);
            break;
        case 32:
            printf("\nDECLARE error: in program line: %d.\n",(x+1));
            printf("DECLARE %s\n",p_string);
            printf("Usage: DECLARE SUB SubName(parameter list).\n");
            printf("code(%d)\n",code);
            break;
        case 54:
            printf("\nError: in program line: %d.\n",(line_ndx+1));
            printf("%s", p_string);
            printf("\nDid not find Window Handle Name.\ncode(%d)\n", code);
            break;
        case 55:
            printf("\nError: in program line: %d.\n",(line_ndx+1));
            printf("%s", p_string);
            printf("\nDid not find window name.\ncode(%d)\n", code);
            break;
        case 56:
            printf("\nError: in program line: %d.\n",(line_ndx+1));
            printf("%s", p_string);
            printf("\nDid not find Window ID name.\ncode(%d)\n", code);
            break;



        default:
            printf("Program aborted, undefined error.");
            break;
    }
    exit(1);
}
/*---------- end a_bort ----------*/



void dump()						/* diagnostic tool */
{  int ii;
                            /* dump program array */
    for(ii = 0; ii < nrows; ii++)
    {
        printf("%d:%d %s:%s", ii, byte_array[ii], label_nam[ii], array1[ii]);
    }
                            /* dump objects array */
/*    for(ii = 0; ii < ObjNdxCnt; ii++)
    {
        printf("%d %s: %d\n", ii, ObjIndx[ii], ObjType[ii]);
    }
*/
    exit(0);
}
/* ----------- end dump ---------- */

