;--- include file created by h2incx v0.99.20 (copyright 2005-2009 japheth)
;--- source file: C:\PROGRA~2\MinGW-461\include\direct.h, last modified: 8/23/2011 15:59
;--- cmdline used for creation: -b -c -d0 -o inc -y *.h

;*
;* direct.h
;* This file has no copyright assigned and is placed in the Public Domain.
;* This file is a part of the mingw-runtime package.
;* No warranty is given; refer to the file DISCLAIMER within the package.
;*
;* Functions for manipulating paths and directories (included from io.h)
;* plus functions for setting the current drive.
;*
;*
ifndef _DIRECT_H_
_DIRECT_H_	EQU	<>
;* All the headers include this file. *
;	include _mingw.inc
__need_wchar_t	EQU	<>
ifndef RC_INVOKED
;	include stddef.inc
;* Not RC_INVOKED *
endif 
;	include io.inc
ifndef RC_INVOKED
ifdef __cplusplus
;extern "C"
;{
endif 
ifndef _DISKFREE_T_DEFINED
;* needed by _getdiskfree (also in dos.h) *
_diskfree_t	struct 
total_clusters	DWORD	?
avail_clusters	DWORD	?
sectors_per_cluster	DWORD	?
bytes_per_sector	DWORD	?
_diskfree_t	ends

_DISKFREE_T_DEFINED	EQU	<>
endif 
;*
;* You really shouldn't be using these. Use the Win32 API functions instead.
;* However, it does make it easier to port older code.
;*
_getdrive proto c 
_getdrives proto c 
_chdrive proto c :DWORD
_getdcwd proto c :DWORD, :ptr SBYTE, :DWORD
_getdiskfree proto c :DWORD, :ptr _diskfree_t
ifndef _NO_OLDNAMES
diskfree_t	EQU	<_diskfree_t>
endif 
ifndef _WDIRECT_DEFINED
;* wide character versions. Also in wchar.h *
ifdef __MSVCRT__
_wchdir proto c :ptr WORD
_wgetcwd proto c :ptr WORD, :DWORD
_wgetdcwd proto c :DWORD, :ptr WORD, :DWORD
_wmkdir proto c :ptr WORD
_wrmdir proto c :ptr WORD
;* __MSVCRT__ *
endif 
_WDIRECT_DEFINED	EQU	<>
endif 
ifdef __cplusplus
;}
endif 
;* Not RC_INVOKED *
endif 
;* Not _DIRECT_H_ *
endif 

;--- errors: 0
;--- end of file ---
